/* database.c generated by valac 0.48.3, the Vala compiler
 * generated from database.vala, do not modify */

/* Copyright 2017 Siddhartha Das (bablu.boy@gmail.com)
*
* This file is part of Bookworm and manages all the Database interactions
*
* Bookworm is free software: you can redistribute it
* and/or modify it under the terms of the GNU General Public License as
* published by the Free Software Foundation, either version 3 of the
* License, or (at your option) any later version.
*
* Bookworm is distributed in the hope that it will be
* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
* Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with Bookworm. If not, see http://www.gnu.org/licenses/.
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <sqlite3.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>

#define BOOKWORM_APP_TYPE_DB (bookworm_app_db_get_type ())
#define BOOKWORM_APP_DB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BOOKWORM_APP_TYPE_DB, BookwormAppDB))
#define BOOKWORM_APP_DB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BOOKWORM_APP_TYPE_DB, BookwormAppDBClass))
#define BOOKWORM_APP_IS_DB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BOOKWORM_APP_TYPE_DB))
#define BOOKWORM_APP_IS_DB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BOOKWORM_APP_TYPE_DB))
#define BOOKWORM_APP_DB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BOOKWORM_APP_TYPE_DB, BookwormAppDBClass))

typedef struct _BookwormAppDB BookwormAppDB;
typedef struct _BookwormAppDBClass BookwormAppDBClass;
typedef struct _BookwormAppDBPrivate BookwormAppDBPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _sqlite3_close0(var) ((var == NULL) ? NULL : (var = (sqlite3_close (var), NULL)))
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define BOOKWORM_APP_TYPE_BOOK (bookworm_app_book_get_type ())
#define BOOKWORM_APP_BOOK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BOOKWORM_APP_TYPE_BOOK, BookwormAppBook))
#define BOOKWORM_APP_BOOK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BOOKWORM_APP_TYPE_BOOK, BookwormAppBookClass))
#define BOOKWORM_APP_IS_BOOK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BOOKWORM_APP_TYPE_BOOK))
#define BOOKWORM_APP_IS_BOOK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BOOKWORM_APP_TYPE_BOOK))
#define BOOKWORM_APP_BOOK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BOOKWORM_APP_TYPE_BOOK, BookwormAppBookClass))

typedef struct _BookwormAppBook BookwormAppBook;
typedef struct _BookwormAppBookClass BookwormAppBookClass;
#define _bookworm_app_book_unref0(var) ((var == NULL) ? NULL : (var = (bookworm_app_book_unref (var), NULL)))
typedef struct _BookwormAppParamSpecDB BookwormAppParamSpecDB;

struct _BookwormAppDB {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BookwormAppDBPrivate * priv;
};

struct _BookwormAppDBClass {
	GTypeClass parent_class;
	void (*finalize) (BookwormAppDB *self);
};

struct _BookwormAppParamSpecDB {
	GParamSpec parent_instance;
};

static gpointer bookworm_app_db_parent_class = NULL;
static sqlite3* bookworm_app_db_bookwormDB;
static sqlite3* bookworm_app_db_bookwormDB = NULL;
static gchar* bookworm_app_db_errmsg;
static gchar* bookworm_app_db_errmsg = NULL;
static gchar* bookworm_app_db_queryString;
static gchar* bookworm_app_db_queryString = NULL;
static gint bookworm_app_db_executionStatus;
static gint bookworm_app_db_executionStatus = 0;
extern gchar* bookworm_app_bookworm_no_of_books_per_page;
extern GString* bookworm_app_bookworm_pathsOfBooksInLibraryOnLoadStr;
extern GeeArrayList* bookworm_app_bookworm_paginationlist;

gpointer bookworm_app_db_ref (gpointer instance);
void bookworm_app_db_unref (gpointer instance);
GParamSpec* bookworm_app_param_spec_db (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void bookworm_app_value_set_db (GValue* value,
                                gpointer v_object);
void bookworm_app_value_take_db (GValue* value,
                                 gpointer v_object);
gpointer bookworm_app_value_get_db (const GValue* value);
GType bookworm_app_db_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BookwormAppDB, bookworm_app_db_unref)
#define BOOKWORM_APP_DB_BOOKWORM_TABLE_BASE_NAME "BOOK_LIBRARY_TABLE"
#define BOOKWORM_APP_DB_BOOKWORM_TABLE_VERSION "6"
#define BOOKWORM_APP_DB_BOOKWORM_TABLE_NAME BOOKWORM_APP_DB_BOOKWORM_TABLE_BASE_NAME BOOKWORM_APP_DB_BOOKWORM_TABLE_VERSION
#define BOOKWORM_APP_DB_BOOKMETADATA_TABLE_BASE_NAME "BOOK_METADATA_TABLE"
#define BOOKWORM_APP_DB_BOOKMETADATA_TABLE_VERSION "1"
#define BOOKWORM_APP_DB_BOOKMETADATA_TABLE_NAME BOOKWORM_APP_DB_BOOKMETADATA_TABLE_BASE_NAME BOOKWORM_APP_DB_BOOKMETADATA_TABLE_VERSION
#define BOOKWORM_APP_DB_VERSION_TABLE_BASE_NAME "VERSION_TABLE"
#define BOOKWORM_APP_DB_VERSION_TABLE_VERSION "1"
gboolean bookworm_app_db_initializeBookWormDB (const gchar* bookworm_config_path);
static void bookworm_app_db_report_query_execution_error (const gchar* query,
                                                   gint errcode,
                                                   const gchar* errmsg);
gpointer bookworm_app_book_ref (gpointer instance);
void bookworm_app_book_unref (gpointer instance);
GParamSpec* bookworm_app_param_spec_book (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
void bookworm_app_value_set_book (GValue* value,
                                  gpointer v_object);
void bookworm_app_value_take_book (GValue* value,
                                   gpointer v_object);
gpointer bookworm_app_value_get_book (const GValue* value);
GType bookworm_app_book_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BookwormAppBook, bookworm_app_book_unref)
GeeArrayList* bookworm_app_db_getBooksFromDB (const gchar* criteria,
                                              const gchar* mode);
BookwormAppBook* bookworm_app_book_new (void);
BookwormAppBook* bookworm_app_book_construct (GType object_type);
void bookworm_app_book_setBookId (BookwormAppBook* self,
                                  gint aBookId);
void bookworm_app_book_setBookLocation (BookwormAppBook* self,
                                        const gchar* aBookLocation);
void bookworm_app_book_setBookTitle (BookwormAppBook* self,
                                     const gchar* aBookTitle);
void bookworm_app_book_setBookAuthor (BookwormAppBook* self,
                                      const gchar* aBookAuthor);
void bookworm_app_book_setBookCoverLocation (BookwormAppBook* self,
                                             const gchar* aBookCoverLocation);
void bookworm_app_book_setIsBookCoverImagePresent (BookwormAppBook* self,
                                                   gboolean isABookCoverImagePresent);
void bookworm_app_book_setBookPageNumber (BookwormAppBook* self,
                                          gint aBookPageNumber);
void bookworm_app_book_setBookPublishDate (BookwormAppBook* self,
                                           const gchar* aBookPublishDate);
void bookworm_app_book_setBookTags (BookwormAppBook* self,
                                    const gchar* aBookTags);
void bookworm_app_book_setAnnotationTags (BookwormAppBook* self,
                                          const gchar* anAnnotationTags);
void bookworm_app_book_setBookRating (BookwormAppBook* self,
                                      gint aBookRating);
void bookworm_app_book_setBookExtractionLocation (BookwormAppBook* self,
                                                  const gchar* aBookExtractionLocation);
void bookworm_app_book_setBookTotalPages (BookwormAppBook* self,
                                          gint aBookTotalPages);
void bookworm_app_book_setBookCreationDate (BookwormAppBook* self,
                                            const gchar* aBookCreationDate);
void bookworm_app_book_setBookLastModificationDate (BookwormAppBook* self,
                                                    const gchar* aBookLastModificationDate);
gchar* bookworm_app_book_getBookLocation (BookwormAppBook* self);
gchar* bookworm_app_book_getBookLastModificationDate (BookwormAppBook* self);
BookwormAppBook* bookworm_app_db_getBookFromDB (const gchar* book_location);
BookwormAppBook* bookworm_app_db_getBookMetaDataFromDB (BookwormAppBook* aBook);
gint bookworm_app_book_getBookId (BookwormAppBook* self);
BookwormAppBook* bookworm_app_utils_convertStringToTOC (BookwormAppBook* aBook,
                                                        const gchar* tocString);
void bookworm_app_book_setBookmark (BookwormAppBook* self,
                                    gint pageNumber,
                                    const gchar* action);
BookwormAppBook* bookworm_app_utils_convertStringToContentList (BookwormAppBook* aBook,
                                                                const gchar* contentListString);
void bookworm_app_book_setBookScrollPos (BookwormAppBook* self,
                                         gint aBookScrollPos);
void bookworm_app_book_setAnnotationList (BookwormAppBook* self,
                                          GeeTreeMap* aTreeMap);
GeeTreeMap* bookworm_app_utils_convertStringToTreeMap (const gchar* stringForTreeMap);
gint bookworm_app_db_addBookToDataBase (BookwormAppBook* aBook);
gchar* bookworm_app_book_getBookTitle (BookwormAppBook* self);
gchar* bookworm_app_book_getBookAuthor (BookwormAppBook* self);
gchar* bookworm_app_book_getBookCoverLocation (BookwormAppBook* self);
gboolean bookworm_app_book_getIsBookCoverImagePresent (BookwormAppBook* self);
gchar* bookworm_app_book_getBookExtractionLocation (BookwormAppBook* self);
gboolean bookworm_app_db_removeBookFromDB (BookwormAppBook* aBook);
gboolean bookworm_app_db_updateBookToDataBase (BookwormAppBook* aBook);
gchar* bookworm_app_book_to_string (BookwormAppBook* self);
gint bookworm_app_book_getBookPageNumber (BookwormAppBook* self);
gchar* bookworm_app_book_getBookTags (BookwormAppBook* self);
gchar* bookworm_app_book_getAnnotationTags (BookwormAppBook* self);
gint bookworm_app_book_getBookRating (BookwormAppBook* self);
gint bookworm_app_book_getBookTotalPages (BookwormAppBook* self);
gchar* bookworm_app_utils_convertTOCToString (BookwormAppBook* aBook);
gchar* bookworm_app_book_getBookmark (BookwormAppBook* self);
gchar* bookworm_app_utils_convertContentListToString (BookwormAppBook* aBook);
gint bookworm_app_book_getBookScrollPos (BookwormAppBook* self);
gchar* bookworm_app_utils_convertTreeMapToString (GeeTreeMap* aMap);
GeeTreeMap* bookworm_app_book_getAnnotationList (BookwormAppBook* self);
GeeArrayList* bookworm_app_db_getBookIDListFromDB (void);
BookwormAppDB* bookworm_app_db_new (void);
BookwormAppDB* bookworm_app_db_construct (GType object_type);
static void bookworm_app_db_finalize (BookwormAppDB * obj);
static GType bookworm_app_db_get_type_once (void);

static gint
_sqlite3_exec (sqlite3* self,
               const gchar* sql,
               sqlite3_callback callback,
               gpointer callback_target,
               gchar* * errmsg)
{
	gchar* _vala_errmsg = NULL;
	const gchar* sqlite_errmsg = NULL;
	gint ec = 0;
	const gchar* _tmp0_ = NULL;
	gint _tmp1_;
	const gchar* _tmp4_;
	gint result = 0;
#line 34 "sqlite3.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 34 "sqlite3.vapi"
	g_return_val_if_fail (sql != NULL, 0);
#line 36 "sqlite3.vapi"
	_tmp1_ = sqlite3_exec (self, sql, callback, callback_target, (char**) (&_tmp0_));
#line 36 "sqlite3.vapi"
	sqlite_errmsg = _tmp0_;
#line 36 "sqlite3.vapi"
	ec = _tmp1_;
#line 37 "sqlite3.vapi"
	if ((&_vala_errmsg) != NULL) {
#line 229 "database.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 38 "sqlite3.vapi"
		_tmp2_ = sqlite_errmsg;
#line 38 "sqlite3.vapi"
		_tmp3_ = g_strdup (_tmp2_);
#line 38 "sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 38 "sqlite3.vapi"
		_vala_errmsg = _tmp3_;
#line 240 "database.c"
	} else {
#line 40 "sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 40 "sqlite3.vapi"
		_vala_errmsg = NULL;
#line 246 "database.c"
	}
#line 42 "sqlite3.vapi"
	_tmp4_ = sqlite_errmsg;
#line 42 "sqlite3.vapi"
	sqlite3_free ((void*) _tmp4_);
#line 43 "sqlite3.vapi"
	result = ec;
#line 43 "sqlite3.vapi"
	if (errmsg) {
#line 43 "sqlite3.vapi"
		*errmsg = _vala_errmsg;
#line 258 "database.c"
	} else {
#line 43 "sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 262 "database.c"
	}
#line 43 "sqlite3.vapi"
	return result;
#line 266 "database.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
#line 1359 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1360 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1360 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1361 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1362 "glib-2.0.vapi"
	result = _result_;
#line 1362 "glib-2.0.vapi"
	return result;
#line 287 "database.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 111 "../src/database.vala"
	return self ? g_object_ref (self) : NULL;
#line 295 "database.c"
}

gboolean
bookworm_app_db_initializeBookWormDB (const gchar* bookworm_config_path)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	sqlite3_stmt* stmt = NULL;
	gint dbOpenStatus = 0;
	gchar* _tmp2_;
	gchar* _tmp3_;
	sqlite3* _tmp4_ = NULL;
	gint _tmp5_;
	gint _tmp6_;
	gchar* _tmp16_;
	sqlite3* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_ = NULL;
	gint _tmp20_;
	gchar* _tmp25_;
	sqlite3* _tmp26_;
	const gchar* _tmp27_;
	gchar* _tmp28_ = NULL;
	gint _tmp29_;
	GeeArrayList* listOfTables = NULL;
	GeeArrayList* _tmp34_;
	gchar* _tmp35_;
	sqlite3* _tmp36_;
	const gchar* _tmp37_;
	const gchar* _tmp38_;
	gint _tmp39_;
	gint _tmp40_;
	sqlite3_stmt* _tmp41_ = NULL;
	gint _tmp42_;
	sqlite3_stmt* _tmp53_;
	GeeArrayList* _tmp54_;
	GeeArrayList* _tmp55_;
	gboolean result = FALSE;
#line 36 "../src/database.vala"
	g_return_val_if_fail (bookworm_config_path != NULL, FALSE);
#line 37 "../src/database.vala"
	_tmp0_ = g_strconcat ("[START] [FUNCTION:initializeBookWormDB] bookworm_config_path=", bookworm_config_path, NULL);
#line 37 "../src/database.vala"
	_tmp1_ = _tmp0_;
#line 37 "../src/database.vala"
	g_info ("database.vala:37: %s", _tmp1_);
#line 37 "../src/database.vala"
	_g_free0 (_tmp1_);
#line 39 "../src/database.vala"
	g_debug ("database.vala:39: Checking BookWorm DB or creating it if the DB does n" \
"ot exist...");
#line 40 "../src/database.vala"
	_tmp2_ = g_strconcat (bookworm_config_path, "/bookworm.db", NULL);
#line 40 "../src/database.vala"
	_tmp3_ = _tmp2_;
#line 40 "../src/database.vala"
	_tmp5_ = sqlite3_open_v2 (_tmp3_, &_tmp4_, SQLITE_OPEN_READWRITE | SQLITE_OPEN_CREATE, NULL);
#line 40 "../src/database.vala"
	_sqlite3_close0 (bookworm_app_db_bookwormDB);
#line 40 "../src/database.vala"
	bookworm_app_db_bookwormDB = _tmp4_;
#line 40 "../src/database.vala"
	_tmp6_ = _tmp5_;
#line 40 "../src/database.vala"
	_g_free0 (_tmp3_);
#line 40 "../src/database.vala"
	dbOpenStatus = _tmp6_;
#line 42 "../src/database.vala"
	if (dbOpenStatus != SQLITE_OK) {
#line 364 "database.c"
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		sqlite3* _tmp13_;
		sqlite3* _tmp14_;
		const gchar* _tmp15_;
#line 43 "../src/database.vala"
		_tmp7_ = g_strconcat ("Error in opening database[", bookworm_config_path, NULL);
#line 43 "../src/database.vala"
		_tmp8_ = _tmp7_;
#line 43 "../src/database.vala"
		_tmp9_ = g_strconcat (_tmp8_, "/bookworm.db", NULL);
#line 43 "../src/database.vala"
		_tmp10_ = _tmp9_;
#line 43 "../src/database.vala"
		_tmp11_ = g_strconcat (_tmp10_, "]: %d: %s\n", NULL);
#line 43 "../src/database.vala"
		_tmp12_ = _tmp11_;
#line 43 "../src/database.vala"
		_tmp13_ = bookworm_app_db_bookwormDB;
#line 43 "../src/database.vala"
		_tmp14_ = bookworm_app_db_bookwormDB;
#line 43 "../src/database.vala"
		_tmp15_ = sqlite3_errmsg (_tmp14_);
#line 43 "../src/database.vala"
		g_warning (_tmp12_, sqlite3_errcode (_tmp13_), _tmp15_);
#line 43 "../src/database.vala"
		_g_free0 (_tmp12_);
#line 43 "../src/database.vala"
		_g_free0 (_tmp10_);
#line 43 "../src/database.vala"
		_g_free0 (_tmp8_);
#line 44 "../src/database.vala"
		result = FALSE;
#line 44 "../src/database.vala"
		_sqlite3_finalize0 (stmt);
#line 44 "../src/database.vala"
		return result;
#line 406 "database.c"
	} else {
#line 46 "../src/database.vala"
		g_debug ("database.vala:46: Successfully checked/created DB for Bookworm.....");
#line 410 "database.c"
	}
#line 49 "../src/database.vala"
	g_debug ("database.vala:49: Creating latest version for Library table if it does" \
" not exists");
#line 50 "../src/database.vala"
	_tmp16_ = g_strdup ("CREATE TABLE IF NOT EXISTS " BOOKWORM_APP_DB_BOOKWORM_TABLE_NAME " (" "id INTEGER PRIMARY KEY AUTOINCREMENT, " "BOOK_LOCATION TEXT NOT NULL DEFAULT '', " "BOOK_TITLE TEXT NOT NULL DEFAULT '', " "BOOK_AUTHOR TEXT NOT NULL DEFAULT '', " "BOOK_COVER_IMAGE_LOCATION TEXT NOT NULL DEFAULT '', " "IS_BOOK_COVER_IMAGE_PRESENT TEXT NOT NULL DEFAULT '', " "BOOK_PUBLISH_DATE TEXT NOT NULL DEFAULT '', " "BOOK_TOTAL_NUMBER_OF_PAGES TEXT NOT NULL DEFAULT '', " "BOOK_LAST_READ_PAGE_NUMBER TEXT NOT NULL DEFAULT '', " "BOOK_TOTAL_PAGES TEXT NOT NULL DEFAULT '', " "TAGS TEXT NOT NULL DEFAULT '', " "ANNOTATION_TAGS TEXT NOT NULL DEFAULT '', " "RATINGS TEXT NOT NULL DEFAULT '', " "CONTENT_EXTRACTION_LOCATION TEXT NOT NULL DEFAULT '', " "creation_date INTEGER," "modification_date INTEGER)");
#line 50 "../src/database.vala"
	_g_free0 (bookworm_app_db_queryString);
#line 50 "../src/database.vala"
	bookworm_app_db_queryString = _tmp16_;
#line 67 "../src/database.vala"
	_tmp17_ = bookworm_app_db_bookwormDB;
#line 67 "../src/database.vala"
	_tmp18_ = bookworm_app_db_queryString;
#line 67 "../src/database.vala"
	_tmp20_ = _sqlite3_exec (_tmp17_, _tmp18_, NULL, NULL, &_tmp19_);
#line 67 "../src/database.vala"
	_g_free0 (bookworm_app_db_errmsg);
#line 67 "../src/database.vala"
	bookworm_app_db_errmsg = _tmp19_;
#line 67 "../src/database.vala"
	bookworm_app_db_executionStatus = _tmp20_;
#line 68 "../src/database.vala"
	if (bookworm_app_db_executionStatus != SQLITE_OK) {
#line 434 "database.c"
		const gchar* _tmp21_;
		sqlite3* _tmp22_;
		sqlite3* _tmp23_;
		const gchar* _tmp24_;
#line 69 "../src/database.vala"
		_tmp21_ = bookworm_app_db_queryString;
#line 69 "../src/database.vala"
		_tmp22_ = bookworm_app_db_bookwormDB;
#line 69 "../src/database.vala"
		_tmp23_ = bookworm_app_db_bookwormDB;
#line 69 "../src/database.vala"
		_tmp24_ = sqlite3_errmsg (_tmp23_);
#line 69 "../src/database.vala"
		bookworm_app_db_report_query_execution_error (_tmp21_, sqlite3_errcode (_tmp22_), _tmp24_);
#line 70 "../src/database.vala"
		result = FALSE;
#line 70 "../src/database.vala"
		_sqlite3_finalize0 (stmt);
#line 70 "../src/database.vala"
		return result;
#line 455 "database.c"
	} else {
#line 72 "../src/database.vala"
		g_debug ("database.vala:72: %s", "Successfully checked/created table:" BOOKWORM_APP_DB_BOOKWORM_TABLE_NAME);
#line 459 "database.c"
	}
#line 75 "../src/database.vala"
	g_debug ("database.vala:75: Creating latest version for Book Metadata table if i" \
"t does not exists");
#line 76 "../src/database.vala"
	_tmp25_ = g_strdup ("CREATE TABLE IF NOT EXISTS " BOOKWORM_APP_DB_BOOKMETADATA_TABLE_NAME " (" "id INTEGER PRIMARY KEY, " "BOOK_TOC_DATA TEXT NOT NULL DEFAULT '', " "BOOKMARKS TEXT NOT NULL DEFAULT '', " "CONTENT_DATA_LIST TEXT NOT NULL DEFAULT '', " "BOOK_LAST_SCROLL_POSITION TEXT NOT NULL DEFAULT '', " "BOOK_ANNOTATIONS TEXT NOT NULL DEFAULT '', " "creation_date INTEGER," "modification_date INTEGER)");
#line 76 "../src/database.vala"
	_g_free0 (bookworm_app_db_queryString);
#line 76 "../src/database.vala"
	bookworm_app_db_queryString = _tmp25_;
#line 85 "../src/database.vala"
	_tmp26_ = bookworm_app_db_bookwormDB;
#line 85 "../src/database.vala"
	_tmp27_ = bookworm_app_db_queryString;
#line 85 "../src/database.vala"
	_tmp29_ = _sqlite3_exec (_tmp26_, _tmp27_, NULL, NULL, &_tmp28_);
#line 85 "../src/database.vala"
	_g_free0 (bookworm_app_db_errmsg);
#line 85 "../src/database.vala"
	bookworm_app_db_errmsg = _tmp28_;
#line 85 "../src/database.vala"
	bookworm_app_db_executionStatus = _tmp29_;
#line 86 "../src/database.vala"
	if (bookworm_app_db_executionStatus != SQLITE_OK) {
#line 483 "database.c"
		const gchar* _tmp30_;
		sqlite3* _tmp31_;
		sqlite3* _tmp32_;
		const gchar* _tmp33_;
#line 87 "../src/database.vala"
		_tmp30_ = bookworm_app_db_queryString;
#line 87 "../src/database.vala"
		_tmp31_ = bookworm_app_db_bookwormDB;
#line 87 "../src/database.vala"
		_tmp32_ = bookworm_app_db_bookwormDB;
#line 87 "../src/database.vala"
		_tmp33_ = sqlite3_errmsg (_tmp32_);
#line 87 "../src/database.vala"
		bookworm_app_db_report_query_execution_error (_tmp30_, sqlite3_errcode (_tmp31_), _tmp33_);
#line 88 "../src/database.vala"
		result = FALSE;
#line 88 "../src/database.vala"
		_sqlite3_finalize0 (stmt);
#line 88 "../src/database.vala"
		return result;
#line 504 "database.c"
	} else {
#line 90 "../src/database.vala"
		g_debug ("database.vala:90: %s", "Successfully checked/created table:" BOOKWORM_APP_DB_BOOKMETADATA_TABLE_NAME);
#line 508 "database.c"
	}
#line 94 "../src/database.vala"
	_tmp34_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 94 "../src/database.vala"
	listOfTables = _tmp34_;
#line 95 "../src/database.vala"
	_tmp35_ = g_strdup ("SELECT NAME FROM SQLITE_MASTER WHERE TYPE='table' ORDER BY NAME");
#line 95 "../src/database.vala"
	_g_free0 (bookworm_app_db_queryString);
#line 95 "../src/database.vala"
	bookworm_app_db_queryString = _tmp35_;
#line 96 "../src/database.vala"
	_tmp36_ = bookworm_app_db_bookwormDB;
#line 96 "../src/database.vala"
	_tmp37_ = bookworm_app_db_queryString;
#line 96 "../src/database.vala"
	_tmp38_ = bookworm_app_db_queryString;
#line 96 "../src/database.vala"
	_tmp39_ = strlen (_tmp38_);
#line 96 "../src/database.vala"
	_tmp40_ = _tmp39_;
#line 96 "../src/database.vala"
	_tmp42_ = sqlite3_prepare_v2 (_tmp36_, _tmp37_, _tmp40_, &_tmp41_, NULL);
#line 96 "../src/database.vala"
	_sqlite3_finalize0 (stmt);
#line 96 "../src/database.vala"
	stmt = _tmp41_;
#line 96 "../src/database.vala"
	bookworm_app_db_executionStatus = _tmp42_;
#line 97 "../src/database.vala"
	if (bookworm_app_db_executionStatus != SQLITE_OK) {
#line 540 "database.c"
		const gchar* _tmp43_;
		sqlite3* _tmp44_;
		sqlite3* _tmp45_;
		const gchar* _tmp46_;
#line 98 "../src/database.vala"
		_tmp43_ = bookworm_app_db_queryString;
#line 98 "../src/database.vala"
		_tmp44_ = bookworm_app_db_bookwormDB;
#line 98 "../src/database.vala"
		_tmp45_ = bookworm_app_db_bookwormDB;
#line 98 "../src/database.vala"
		_tmp46_ = sqlite3_errmsg (_tmp45_);
#line 98 "../src/database.vala"
		bookworm_app_db_report_query_execution_error (_tmp43_, sqlite3_errcode (_tmp44_), _tmp46_);
#line 555 "database.c"
	}
#line 100 "../src/database.vala"
	while (TRUE) {
#line 559 "database.c"
		sqlite3_stmt* _tmp47_;
		GeeArrayList* _tmp48_;
		sqlite3_stmt* _tmp49_;
		const gchar* _tmp50_;
		gchar* _tmp51_;
		gchar* _tmp52_;
#line 100 "../src/database.vala"
		_tmp47_ = stmt;
#line 100 "../src/database.vala"
		if (!(sqlite3_step (_tmp47_) == SQLITE_ROW)) {
#line 100 "../src/database.vala"
			break;
#line 572 "database.c"
		}
#line 101 "../src/database.vala"
		_tmp48_ = listOfTables;
#line 101 "../src/database.vala"
		_tmp49_ = stmt;
#line 101 "../src/database.vala"
		_tmp50_ = (const gchar*) sqlite3_column_text (_tmp49_, 0);
#line 101 "../src/database.vala"
		_tmp51_ = string_strip (_tmp50_);
#line 101 "../src/database.vala"
		_tmp52_ = _tmp51_;
#line 101 "../src/database.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp48_, _tmp52_);
#line 101 "../src/database.vala"
		_g_free0 (_tmp52_);
#line 588 "database.c"
	}
#line 103 "../src/database.vala"
	_tmp53_ = stmt;
#line 103 "../src/database.vala"
	sqlite3_reset (_tmp53_);
#line 106 "../src/database.vala"
	_tmp54_ = listOfTables;
#line 106 "../src/database.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp54_, BOOKWORM_APP_DB_BOOKWORM_TABLE_NAME);
#line 107 "../src/database.vala"
	_tmp55_ = listOfTables;
#line 107 "../src/database.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp55_, BOOKWORM_APP_DB_BOOKMETADATA_TABLE_NAME);
#line 602 "database.c"
	{
		GeeArrayList* _old_table_name_list = NULL;
		GeeArrayList* _tmp56_;
		GeeArrayList* _tmp57_;
		gint _old_table_name_size = 0;
		GeeArrayList* _tmp58_;
		gint _tmp59_;
		gint _tmp60_;
		gint _old_table_name_index = 0;
#line 111 "../src/database.vala"
		_tmp56_ = listOfTables;
#line 111 "../src/database.vala"
		_tmp57_ = _g_object_ref0 (_tmp56_);
#line 111 "../src/database.vala"
		_old_table_name_list = _tmp57_;
#line 111 "../src/database.vala"
		_tmp58_ = _old_table_name_list;
#line 111 "../src/database.vala"
		_tmp59_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp58_);
#line 111 "../src/database.vala"
		_tmp60_ = _tmp59_;
#line 111 "../src/database.vala"
		_old_table_name_size = _tmp60_;
#line 111 "../src/database.vala"
		_old_table_name_index = -1;
#line 111 "../src/database.vala"
		while (TRUE) {
#line 630 "database.c"
			gchar* old_table_name = NULL;
			GeeArrayList* _tmp61_;
			gpointer _tmp62_;
			const gchar* _tmp63_;
			const gchar* _tmp109_;
#line 111 "../src/database.vala"
			_old_table_name_index = _old_table_name_index + 1;
#line 111 "../src/database.vala"
			if (!(_old_table_name_index < _old_table_name_size)) {
#line 111 "../src/database.vala"
				break;
#line 642 "database.c"
			}
#line 111 "../src/database.vala"
			_tmp61_ = _old_table_name_list;
#line 111 "../src/database.vala"
			_tmp62_ = gee_abstract_list_get ((GeeAbstractList*) _tmp61_, _old_table_name_index);
#line 111 "../src/database.vala"
			old_table_name = (gchar*) _tmp62_;
#line 113 "../src/database.vala"
			_tmp63_ = old_table_name;
#line 113 "../src/database.vala"
			if (g_strcmp0 (_tmp63_, "BOOK_LIBRARY_TABLE5") == 0) {
#line 654 "database.c"
				gchar* _tmp64_;
				sqlite3* _tmp65_;
				const gchar* _tmp66_;
				gchar* _tmp67_ = NULL;
				gint _tmp68_;
#line 115 "../src/database.vala"
				_tmp64_ = g_strdup ("INSERT INTO " BOOKWORM_APP_DB_BOOKWORM_TABLE_NAME " (" "id, BOOK_LOCATION, BOOK_TITLE, BOOK_AUTHOR, BOOK_COVER_IMAGE_LOCATION," \
" " "IS_BOOK_COVER_IMAGE_PRESENT, BOOK_PUBLISH_DATE, BOOK_TOTAL_NUMBER_OF_P" \
"AGES, " "BOOK_LAST_READ_PAGE_NUMBER, TAGS, RATINGS,CONTENT_EXTRACTION_LOCATION," \
" " "creation_date, modification_date) SELECT id, BOOK_LOCATION, BOOK_TITLE" \
", " "BOOK_AUTHOR, BOOK_COVER_IMAGE_LOCATION, IS_BOOK_COVER_IMAGE_PRESENT, " "BOOK_PUBLISH_DATE, BOOK_TOTAL_NUMBER_OF_PAGES, BOOK_LAST_READ_PAGE_NUM" \
"BER, " "TAGS, RATINGS, CONTENT_EXTRACTION_LOCATION, creation_date, " "modification_date FROM BOOK_LIBRARY_TABLE5");
#line 115 "../src/database.vala"
				_g_free0 (bookworm_app_db_queryString);
#line 115 "../src/database.vala"
				bookworm_app_db_queryString = _tmp64_;
#line 124 "../src/database.vala"
				_tmp65_ = bookworm_app_db_bookwormDB;
#line 124 "../src/database.vala"
				_tmp66_ = bookworm_app_db_queryString;
#line 124 "../src/database.vala"
				_tmp68_ = _sqlite3_exec (_tmp65_, _tmp66_, NULL, NULL, &_tmp67_);
#line 124 "../src/database.vala"
				_g_free0 (bookworm_app_db_errmsg);
#line 124 "../src/database.vala"
				bookworm_app_db_errmsg = _tmp67_;
#line 124 "../src/database.vala"
				bookworm_app_db_executionStatus = _tmp68_;
#line 125 "../src/database.vala"
				if (bookworm_app_db_executionStatus != SQLITE_OK) {
#line 680 "database.c"
					const gchar* _tmp69_;
					sqlite3* _tmp70_;
					sqlite3* _tmp71_;
					const gchar* _tmp72_;
#line 126 "../src/database.vala"
					_tmp69_ = bookworm_app_db_queryString;
#line 126 "../src/database.vala"
					_tmp70_ = bookworm_app_db_bookwormDB;
#line 126 "../src/database.vala"
					_tmp71_ = bookworm_app_db_bookwormDB;
#line 126 "../src/database.vala"
					_tmp72_ = sqlite3_errmsg (_tmp71_);
#line 126 "../src/database.vala"
					bookworm_app_db_report_query_execution_error (_tmp69_, sqlite3_errcode (_tmp70_), _tmp72_);
#line 695 "database.c"
				} else {
					sqlite3* _tmp73_;
					gchar* _tmp74_;
					gchar* _tmp75_;
					gchar* _tmp76_;
					gchar* _tmp77_;
					gchar* _tmp78_;
					gchar* _tmp79_;
					gchar* _tmp80_;
					gchar* _tmp81_;
					gchar* _tmp82_;
					sqlite3* _tmp83_;
					const gchar* _tmp84_;
					gchar* _tmp85_ = NULL;
					gint _tmp86_;
#line 128 "../src/database.vala"
					_tmp73_ = bookworm_app_db_bookwormDB;
#line 128 "../src/database.vala"
					_tmp74_ = g_strdup_printf ("%i", sqlite3_changes (_tmp73_));
#line 128 "../src/database.vala"
					_tmp75_ = _tmp74_;
#line 128 "../src/database.vala"
					_tmp76_ = g_strconcat ("Successfully migrated ", _tmp75_, NULL);
#line 128 "../src/database.vala"
					_tmp77_ = _tmp76_;
#line 128 "../src/database.vala"
					_tmp78_ = g_strconcat (_tmp77_, " rows from BOOK_LIBRARY_TABLE5 into ", NULL);
#line 128 "../src/database.vala"
					_tmp79_ = _tmp78_;
#line 128 "../src/database.vala"
					_tmp80_ = g_strconcat (_tmp79_, BOOKWORM_APP_DB_BOOKWORM_TABLE_NAME, NULL);
#line 128 "../src/database.vala"
					_tmp81_ = _tmp80_;
#line 128 "../src/database.vala"
					g_debug ("database.vala:128: %s", _tmp81_);
#line 128 "../src/database.vala"
					_g_free0 (_tmp81_);
#line 128 "../src/database.vala"
					_g_free0 (_tmp79_);
#line 128 "../src/database.vala"
					_g_free0 (_tmp77_);
#line 128 "../src/database.vala"
					_g_free0 (_tmp75_);
#line 130 "../src/database.vala"
					_tmp82_ = g_strdup ("INSERT INTO " BOOKWORM_APP_DB_BOOKMETADATA_TABLE_NAME " (" "id, BOOK_TOC_DATA, BOOKMARKS, CONTENT_DATA_LIST, BOOK_LAST_SCROLL_POSI" \
"TION, " "creation_date, modification_date) SELECT id, BOOK_TOC_DATA, BOOKMARKS," \
" " "CONTENT_DATA_LIST, BOOK_LAST_SCROLL_POSITION, creation_date, " "modification_date FROM BOOK_LIBRARY_TABLE5");
#line 130 "../src/database.vala"
					_g_free0 (bookworm_app_db_queryString);
#line 130 "../src/database.vala"
					bookworm_app_db_queryString = _tmp82_;
#line 135 "../src/database.vala"
					_tmp83_ = bookworm_app_db_bookwormDB;
#line 135 "../src/database.vala"
					_tmp84_ = bookworm_app_db_queryString;
#line 135 "../src/database.vala"
					_tmp86_ = _sqlite3_exec (_tmp83_, _tmp84_, NULL, NULL, &_tmp85_);
#line 135 "../src/database.vala"
					_g_free0 (bookworm_app_db_errmsg);
#line 135 "../src/database.vala"
					bookworm_app_db_errmsg = _tmp85_;
#line 135 "../src/database.vala"
					bookworm_app_db_executionStatus = _tmp86_;
#line 136 "../src/database.vala"
					if (bookworm_app_db_executionStatus != SQLITE_OK) {
#line 759 "database.c"
						const gchar* _tmp87_;
						sqlite3* _tmp88_;
						sqlite3* _tmp89_;
						const gchar* _tmp90_;
#line 137 "../src/database.vala"
						_tmp87_ = bookworm_app_db_queryString;
#line 137 "../src/database.vala"
						_tmp88_ = bookworm_app_db_bookwormDB;
#line 137 "../src/database.vala"
						_tmp89_ = bookworm_app_db_bookwormDB;
#line 137 "../src/database.vala"
						_tmp90_ = sqlite3_errmsg (_tmp89_);
#line 137 "../src/database.vala"
						bookworm_app_db_report_query_execution_error (_tmp87_, sqlite3_errcode (_tmp88_), _tmp90_);
#line 774 "database.c"
					} else {
						sqlite3* _tmp91_;
						gchar* _tmp92_;
						gchar* _tmp93_;
						gchar* _tmp94_;
						gchar* _tmp95_;
						gchar* _tmp96_;
						gchar* _tmp97_;
						gchar* _tmp98_;
						gchar* _tmp99_;
						gchar* _tmp100_;
						sqlite3* _tmp101_;
						const gchar* _tmp102_;
						gchar* _tmp103_ = NULL;
						gint _tmp104_;
#line 139 "../src/database.vala"
						_tmp91_ = bookworm_app_db_bookwormDB;
#line 139 "../src/database.vala"
						_tmp92_ = g_strdup_printf ("%i", sqlite3_changes (_tmp91_));
#line 139 "../src/database.vala"
						_tmp93_ = _tmp92_;
#line 139 "../src/database.vala"
						_tmp94_ = g_strconcat ("Successfully migrated ", _tmp93_, NULL);
#line 139 "../src/database.vala"
						_tmp95_ = _tmp94_;
#line 139 "../src/database.vala"
						_tmp96_ = g_strconcat (_tmp95_, " rows from BOOK_LIBRARY_TABLE5 into", NULL);
#line 139 "../src/database.vala"
						_tmp97_ = _tmp96_;
#line 139 "../src/database.vala"
						_tmp98_ = g_strconcat (_tmp97_, BOOKWORM_APP_DB_BOOKMETADATA_TABLE_NAME, NULL);
#line 139 "../src/database.vala"
						_tmp99_ = _tmp98_;
#line 139 "../src/database.vala"
						g_debug ("database.vala:139: %s", _tmp99_);
#line 139 "../src/database.vala"
						_g_free0 (_tmp99_);
#line 139 "../src/database.vala"
						_g_free0 (_tmp97_);
#line 139 "../src/database.vala"
						_g_free0 (_tmp95_);
#line 139 "../src/database.vala"
						_g_free0 (_tmp93_);
#line 142 "../src/database.vala"
						_tmp100_ = g_strdup ("DROP TABLE IF EXISTS BOOK_LIBRARY_TABLE5");
#line 142 "../src/database.vala"
						_g_free0 (bookworm_app_db_queryString);
#line 142 "../src/database.vala"
						bookworm_app_db_queryString = _tmp100_;
#line 143 "../src/database.vala"
						_tmp101_ = bookworm_app_db_bookwormDB;
#line 143 "../src/database.vala"
						_tmp102_ = bookworm_app_db_queryString;
#line 143 "../src/database.vala"
						_tmp104_ = _sqlite3_exec (_tmp101_, _tmp102_, NULL, NULL, &_tmp103_);
#line 143 "../src/database.vala"
						_g_free0 (bookworm_app_db_errmsg);
#line 143 "../src/database.vala"
						bookworm_app_db_errmsg = _tmp103_;
#line 143 "../src/database.vala"
						bookworm_app_db_executionStatus = _tmp104_;
#line 144 "../src/database.vala"
						if (bookworm_app_db_executionStatus != SQLITE_OK) {
#line 838 "database.c"
							const gchar* _tmp105_;
							sqlite3* _tmp106_;
							sqlite3* _tmp107_;
							const gchar* _tmp108_;
#line 145 "../src/database.vala"
							_tmp105_ = bookworm_app_db_queryString;
#line 145 "../src/database.vala"
							_tmp106_ = bookworm_app_db_bookwormDB;
#line 145 "../src/database.vala"
							_tmp107_ = bookworm_app_db_bookwormDB;
#line 145 "../src/database.vala"
							_tmp108_ = sqlite3_errmsg (_tmp107_);
#line 145 "../src/database.vala"
							bookworm_app_db_report_query_execution_error (_tmp105_, sqlite3_errcode (_tmp106_), _tmp108_);
#line 853 "database.c"
						} else {
#line 147 "../src/database.vala"
							g_debug ("database.vala:147: Successfully dropped old table LIBRARY_TABLE5");
#line 857 "database.c"
						}
					}
				}
			}
#line 153 "../src/database.vala"
			_tmp109_ = old_table_name;
#line 153 "../src/database.vala"
			if (g_strcmp0 (_tmp109_, "VERSION_TABLE") == 0) {
#line 866 "database.c"
				gchar* _tmp110_;
				sqlite3* _tmp111_;
				const gchar* _tmp112_;
				gchar* _tmp113_ = NULL;
				gint _tmp114_;
#line 155 "../src/database.vala"
				_tmp110_ = g_strdup ("DROP TABLE IF EXISTS VERSION_TABLE");
#line 155 "../src/database.vala"
				_g_free0 (bookworm_app_db_queryString);
#line 155 "../src/database.vala"
				bookworm_app_db_queryString = _tmp110_;
#line 156 "../src/database.vala"
				_tmp111_ = bookworm_app_db_bookwormDB;
#line 156 "../src/database.vala"
				_tmp112_ = bookworm_app_db_queryString;
#line 156 "../src/database.vala"
				_tmp114_ = _sqlite3_exec (_tmp111_, _tmp112_, NULL, NULL, &_tmp113_);
#line 156 "../src/database.vala"
				_g_free0 (bookworm_app_db_errmsg);
#line 156 "../src/database.vala"
				bookworm_app_db_errmsg = _tmp113_;
#line 156 "../src/database.vala"
				bookworm_app_db_executionStatus = _tmp114_;
#line 157 "../src/database.vala"
				if (bookworm_app_db_executionStatus != SQLITE_OK) {
#line 892 "database.c"
					const gchar* _tmp115_;
					sqlite3* _tmp116_;
					sqlite3* _tmp117_;
					const gchar* _tmp118_;
#line 158 "../src/database.vala"
					_tmp115_ = bookworm_app_db_queryString;
#line 158 "../src/database.vala"
					_tmp116_ = bookworm_app_db_bookwormDB;
#line 158 "../src/database.vala"
					_tmp117_ = bookworm_app_db_bookwormDB;
#line 158 "../src/database.vala"
					_tmp118_ = sqlite3_errmsg (_tmp117_);
#line 158 "../src/database.vala"
					bookworm_app_db_report_query_execution_error (_tmp115_, sqlite3_errcode (_tmp116_), _tmp118_);
#line 907 "database.c"
				} else {
#line 160 "../src/database.vala"
					g_debug ("database.vala:160: Successfully dropped old table VERSION_TABLE");
#line 911 "database.c"
				}
			}
#line 111 "../src/database.vala"
			_g_free0 (old_table_name);
#line 916 "database.c"
		}
#line 111 "../src/database.vala"
		_g_object_unref0 (_old_table_name_list);
#line 920 "database.c"
	}
#line 165 "../src/database.vala"
	g_info ("database.vala:165: [END] [FUNCTION:initializeBookWormDB]");
#line 166 "../src/database.vala"
	result = TRUE;
#line 166 "../src/database.vala"
	_g_object_unref0 (listOfTables);
#line 166 "../src/database.vala"
	_sqlite3_finalize0 (stmt);
#line 166 "../src/database.vala"
	return result;
#line 932 "database.c"
}

GeeArrayList*
bookworm_app_db_getBooksFromDB (const gchar* criteria,
                                const gchar* mode)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GeeArrayList* listOfBooks = NULL;
	GeeArrayList* _tmp8_;
	sqlite3_stmt* stmt = NULL;
	gchar* last_modification_date = NULL;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gboolean _tmp11_ = FALSE;
	sqlite3* _tmp81_;
	const gchar* _tmp82_;
	const gchar* _tmp83_;
	gint _tmp84_;
	gint _tmp85_;
	sqlite3_stmt* _tmp86_ = NULL;
	gint _tmp87_;
	GeeArrayList* _tmp244_;
	gint _tmp245_;
	gint _tmp246_;
	gchar* _tmp247_;
	gchar* _tmp248_;
	gchar* _tmp249_;
	gchar* _tmp250_;
	gchar* _tmp251_;
	gchar* _tmp252_;
	const gchar* _tmp253_;
	gchar* _tmp254_;
	gchar* _tmp255_;
	gchar* _tmp256_;
	gchar* _tmp257_;
	GeeArrayList* result = NULL;
#line 169 "../src/database.vala"
	g_return_val_if_fail (criteria != NULL, NULL);
#line 169 "../src/database.vala"
	g_return_val_if_fail (mode != NULL, NULL);
#line 170 "../src/database.vala"
	_tmp0_ = g_strconcat ("[START] [FUNCTION:getBooksFromDB] Quering with mode[", mode, NULL);
#line 170 "../src/database.vala"
	_tmp1_ = _tmp0_;
#line 170 "../src/database.vala"
	_tmp2_ = g_strconcat (_tmp1_, "] and criteria[", NULL);
#line 170 "../src/database.vala"
	_tmp3_ = _tmp2_;
#line 170 "../src/database.vala"
	_tmp4_ = g_strconcat (_tmp3_, criteria, NULL);
#line 170 "../src/database.vala"
	_tmp5_ = _tmp4_;
#line 170 "../src/database.vala"
	_tmp6_ = g_strconcat (_tmp5_, "]", NULL);
#line 170 "../src/database.vala"
	_tmp7_ = _tmp6_;
#line 170 "../src/database.vala"
	g_info ("database.vala:170: %s", _tmp7_);
#line 170 "../src/database.vala"
	_g_free0 (_tmp7_);
#line 170 "../src/database.vala"
	_g_free0 (_tmp5_);
#line 170 "../src/database.vala"
	_g_free0 (_tmp3_);
#line 170 "../src/database.vala"
	_g_free0 (_tmp1_);
#line 171 "../src/database.vala"
	_tmp8_ = gee_array_list_new (BOOKWORM_APP_TYPE_BOOK, (GBoxedCopyFunc) bookworm_app_book_ref, (GDestroyNotify) bookworm_app_book_unref, NULL, NULL, NULL);
#line 171 "../src/database.vala"
	listOfBooks = _tmp8_;
#line 173 "../src/database.vala"
	_tmp9_ = g_strdup ("-1");
#line 173 "../src/database.vala"
	last_modification_date = _tmp9_;
#line 174 "../src/database.vala"
	_tmp10_ = g_strdup ("SELECT id, BOOK_LOCATION, BOOK_TITLE, BOOK_AUTHOR, BOOK_COVER_IMAGE_LO" \
"CATION, " "IS_BOOK_COVER_IMAGE_PRESENT, BOOK_LAST_READ_PAGE_NUMBER, BOOK_PUBLISH_" \
"DATE, TAGS, " "ANNOTATION_TAGS, RATINGS, CONTENT_EXTRACTION_LOCATION, BOOK_TOTAL_PAGE" \
"S, creation_date, " "modification_date FROM " BOOKWORM_APP_DB_BOOKWORM_TABLE_NAME);
#line 174 "../src/database.vala"
	_g_free0 (bookworm_app_db_queryString);
#line 174 "../src/database.vala"
	bookworm_app_db_queryString = _tmp10_;
#line 178 "../src/database.vala"
	if (g_strcmp0 (criteria, "") == 0) {
#line 178 "../src/database.vala"
		_tmp11_ = g_strcmp0 (mode, "PAGINATED_SEARCH") == 0;
#line 1024 "database.c"
	} else {
#line 178 "../src/database.vala"
		_tmp11_ = FALSE;
#line 1028 "database.c"
	}
#line 178 "../src/database.vala"
	if (_tmp11_) {
#line 1032 "database.c"
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		const gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
#line 180 "../src/database.vala"
		_tmp12_ = bookworm_app_db_queryString;
#line 180 "../src/database.vala"
		_tmp13_ = g_strconcat (_tmp12_, " ORDER BY modification_date DESC LIMIT ", NULL);
#line 180 "../src/database.vala"
		_tmp14_ = _tmp13_;
#line 180 "../src/database.vala"
		_tmp15_ = bookworm_app_bookworm_no_of_books_per_page;
#line 180 "../src/database.vala"
		_tmp16_ = g_strconcat (_tmp14_, _tmp15_, NULL);
#line 180 "../src/database.vala"
		_g_free0 (bookworm_app_db_queryString);
#line 180 "../src/database.vala"
		bookworm_app_db_queryString = _tmp16_;
#line 180 "../src/database.vala"
		_g_free0 (_tmp14_);
#line 181 "../src/database.vala"
		_tmp17_ = g_strconcat ("Paginated Query with last_modification_date[", criteria, NULL);
#line 181 "../src/database.vala"
		_tmp18_ = _tmp17_;
#line 181 "../src/database.vala"
		_tmp19_ = g_strconcat (_tmp18_, "]:", NULL);
#line 181 "../src/database.vala"
		_tmp20_ = _tmp19_;
#line 181 "../src/database.vala"
		_tmp21_ = bookworm_app_db_queryString;
#line 181 "../src/database.vala"
		_tmp22_ = g_strconcat (_tmp20_, _tmp21_, NULL);
#line 181 "../src/database.vala"
		_tmp23_ = _tmp22_;
#line 181 "../src/database.vala"
		g_debug ("database.vala:181: %s", _tmp23_);
#line 181 "../src/database.vala"
		_g_free0 (_tmp23_);
#line 181 "../src/database.vala"
		_g_free0 (_tmp20_);
#line 181 "../src/database.vala"
		_g_free0 (_tmp18_);
#line 1083 "database.c"
	} else {
#line 182 "../src/database.vala"
		if (g_strcmp0 (mode, "LIBRARY_SEARCH") == 0) {
#line 1087 "database.c"
			const gchar* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
			gchar* _tmp35_;
			gchar* _tmp36_;
			gchar* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
			gchar* _tmp41_;
			gchar* _tmp42_;
			gchar* _tmp43_;
			gchar* _tmp44_;
			gchar* _tmp45_;
			gchar* _tmp46_;
			gchar* _tmp47_;
			gchar* _tmp48_;
			gchar* _tmp49_;
			gchar* _tmp50_;
			gchar* _tmp51_;
			gchar* _tmp52_;
			gchar* _tmp53_;
			gchar* _tmp54_;
			gchar* _tmp55_;
			gchar* _tmp56_;
			gchar* _tmp57_;
			gchar* _tmp58_;
			gchar* _tmp59_;
			const gchar* _tmp60_;
			gchar* _tmp61_;
			gchar* _tmp62_;
#line 184 "../src/database.vala"
			_tmp24_ = bookworm_app_db_queryString;
#line 184 "../src/database.vala"
			_tmp25_ = g_strconcat (_tmp24_, " WHERE ", NULL);
#line 184 "../src/database.vala"
			_tmp26_ = _tmp25_;
#line 184 "../src/database.vala"
			_tmp27_ = g_strconcat (_tmp26_, " BOOK_TITLE LIKE '%", NULL);
#line 184 "../src/database.vala"
			_tmp28_ = _tmp27_;
#line 184 "../src/database.vala"
			_tmp29_ = g_strconcat (_tmp28_, criteria, NULL);
#line 184 "../src/database.vala"
			_tmp30_ = _tmp29_;
#line 184 "../src/database.vala"
			_tmp31_ = g_strconcat (_tmp30_, "%' OR ", NULL);
#line 184 "../src/database.vala"
			_tmp32_ = _tmp31_;
#line 184 "../src/database.vala"
			_tmp33_ = g_strconcat (_tmp32_, " BOOK_LOCATION LIKE '%", NULL);
#line 184 "../src/database.vala"
			_tmp34_ = _tmp33_;
#line 184 "../src/database.vala"
			_tmp35_ = g_strconcat (_tmp34_, criteria, NULL);
#line 184 "../src/database.vala"
			_tmp36_ = _tmp35_;
#line 184 "../src/database.vala"
			_tmp37_ = g_strconcat (_tmp36_, "%' OR ", NULL);
#line 184 "../src/database.vala"
			_tmp38_ = _tmp37_;
#line 184 "../src/database.vala"
			_tmp39_ = g_strconcat (_tmp38_, " BOOK_AUTHOR LIKE '%", NULL);
#line 184 "../src/database.vala"
			_tmp40_ = _tmp39_;
#line 184 "../src/database.vala"
			_tmp41_ = g_strconcat (_tmp40_, criteria, NULL);
#line 184 "../src/database.vala"
			_tmp42_ = _tmp41_;
#line 184 "../src/database.vala"
			_tmp43_ = g_strconcat (_tmp42_, "%' OR ", NULL);
#line 184 "../src/database.vala"
			_tmp44_ = _tmp43_;
#line 184 "../src/database.vala"
			_tmp45_ = g_strconcat (_tmp44_, " TAGS LIKE '%", NULL);
#line 184 "../src/database.vala"
			_tmp46_ = _tmp45_;
#line 184 "../src/database.vala"
			_tmp47_ = g_strconcat (_tmp46_, criteria, NULL);
#line 184 "../src/database.vala"
			_tmp48_ = _tmp47_;
#line 184 "../src/database.vala"
			_tmp49_ = g_strconcat (_tmp48_, "%' OR ", NULL);
#line 184 "../src/database.vala"
			_tmp50_ = _tmp49_;
#line 184 "../src/database.vala"
			_tmp51_ = g_strconcat (_tmp50_, " ANNOTATION_TAGS LIKE '%", NULL);
#line 184 "../src/database.vala"
			_tmp52_ = _tmp51_;
#line 184 "../src/database.vala"
			_tmp53_ = g_strconcat (_tmp52_, criteria, NULL);
#line 184 "../src/database.vala"
			_tmp54_ = _tmp53_;
#line 184 "../src/database.vala"
			_tmp55_ = g_strconcat (_tmp54_, "%'", NULL);
#line 184 "../src/database.vala"
			_g_free0 (bookworm_app_db_queryString);
#line 184 "../src/database.vala"
			bookworm_app_db_queryString = _tmp55_;
#line 184 "../src/database.vala"
			_g_free0 (_tmp54_);
#line 184 "../src/database.vala"
			_g_free0 (_tmp52_);
#line 184 "../src/database.vala"
			_g_free0 (_tmp50_);
#line 184 "../src/database.vala"
			_g_free0 (_tmp48_);
#line 184 "../src/database.vala"
			_g_free0 (_tmp46_);
#line 184 "../src/database.vala"
			_g_free0 (_tmp44_);
#line 184 "../src/database.vala"
			_g_free0 (_tmp42_);
#line 184 "../src/database.vala"
			_g_free0 (_tmp40_);
#line 184 "../src/database.vala"
			_g_free0 (_tmp38_);
#line 184 "../src/database.vala"
			_g_free0 (_tmp36_);
#line 184 "../src/database.vala"
			_g_free0 (_tmp34_);
#line 184 "../src/database.vala"
			_g_free0 (_tmp32_);
#line 184 "../src/database.vala"
			_g_free0 (_tmp30_);
#line 184 "../src/database.vala"
			_g_free0 (_tmp28_);
#line 184 "../src/database.vala"
			_g_free0 (_tmp26_);
#line 190 "../src/database.vala"
			_tmp56_ = g_strconcat ("Library Search Query with criteria[", criteria, NULL);
#line 190 "../src/database.vala"
			_tmp57_ = _tmp56_;
#line 190 "../src/database.vala"
			_tmp58_ = g_strconcat (_tmp57_, "]:", NULL);
#line 190 "../src/database.vala"
			_tmp59_ = _tmp58_;
#line 190 "../src/database.vala"
			_tmp60_ = bookworm_app_db_queryString;
#line 190 "../src/database.vala"
			_tmp61_ = g_strconcat (_tmp59_, _tmp60_, NULL);
#line 190 "../src/database.vala"
			_tmp62_ = _tmp61_;
#line 190 "../src/database.vala"
			g_debug ("database.vala:190: %s", _tmp62_);
#line 190 "../src/database.vala"
			_g_free0 (_tmp62_);
#line 190 "../src/database.vala"
			_g_free0 (_tmp59_);
#line 190 "../src/database.vala"
			_g_free0 (_tmp57_);
#line 1247 "database.c"
		} else {
#line 191 "../src/database.vala"
			if (g_strcmp0 (mode, "PAGINATED_SEARCH") == 0) {
#line 1251 "database.c"
				const gchar* _tmp63_;
				gchar* _tmp64_;
				gchar* _tmp65_;
				gchar* _tmp66_;
				gchar* _tmp67_;
				gchar* _tmp68_;
				gchar* _tmp69_;
				gchar* _tmp70_;
				gchar* _tmp71_;
				const gchar* _tmp72_;
				gchar* _tmp73_;
				gchar* _tmp74_;
				gchar* _tmp75_;
				gchar* _tmp76_;
				gchar* _tmp77_;
				const gchar* _tmp78_;
				gchar* _tmp79_;
				gchar* _tmp80_;
#line 193 "../src/database.vala"
				_tmp63_ = bookworm_app_db_queryString;
#line 193 "../src/database.vala"
				_tmp64_ = g_strconcat (_tmp63_, " where modification_date < CAST ('", NULL);
#line 193 "../src/database.vala"
				_tmp65_ = _tmp64_;
#line 193 "../src/database.vala"
				_tmp66_ = g_strconcat (_tmp65_, criteria, NULL);
#line 193 "../src/database.vala"
				_tmp67_ = _tmp66_;
#line 193 "../src/database.vala"
				_tmp68_ = g_strconcat (_tmp67_, "' AS INT) ", NULL);
#line 193 "../src/database.vala"
				_tmp69_ = _tmp68_;
#line 193 "../src/database.vala"
				_tmp70_ = g_strconcat (_tmp69_, "ORDER BY modification_date DESC LIMIT ", NULL);
#line 193 "../src/database.vala"
				_tmp71_ = _tmp70_;
#line 193 "../src/database.vala"
				_tmp72_ = bookworm_app_bookworm_no_of_books_per_page;
#line 193 "../src/database.vala"
				_tmp73_ = g_strconcat (_tmp71_, _tmp72_, NULL);
#line 193 "../src/database.vala"
				_g_free0 (bookworm_app_db_queryString);
#line 193 "../src/database.vala"
				bookworm_app_db_queryString = _tmp73_;
#line 193 "../src/database.vala"
				_g_free0 (_tmp71_);
#line 193 "../src/database.vala"
				_g_free0 (_tmp69_);
#line 193 "../src/database.vala"
				_g_free0 (_tmp67_);
#line 193 "../src/database.vala"
				_g_free0 (_tmp65_);
#line 195 "../src/database.vala"
				_tmp74_ = g_strconcat ("Paginated Query with last_modification_date[", criteria, NULL);
#line 195 "../src/database.vala"
				_tmp75_ = _tmp74_;
#line 195 "../src/database.vala"
				_tmp76_ = g_strconcat (_tmp75_, "]:", NULL);
#line 195 "../src/database.vala"
				_tmp77_ = _tmp76_;
#line 195 "../src/database.vala"
				_tmp78_ = bookworm_app_db_queryString;
#line 195 "../src/database.vala"
				_tmp79_ = g_strconcat (_tmp77_, _tmp78_, NULL);
#line 195 "../src/database.vala"
				_tmp80_ = _tmp79_;
#line 195 "../src/database.vala"
				g_debug ("database.vala:195: %s", _tmp80_);
#line 195 "../src/database.vala"
				_g_free0 (_tmp80_);
#line 195 "../src/database.vala"
				_g_free0 (_tmp77_);
#line 195 "../src/database.vala"
				_g_free0 (_tmp75_);
#line 1326 "database.c"
			}
		}
	}
#line 197 "../src/database.vala"
	_tmp81_ = bookworm_app_db_bookwormDB;
#line 197 "../src/database.vala"
	_tmp82_ = bookworm_app_db_queryString;
#line 197 "../src/database.vala"
	_tmp83_ = bookworm_app_db_queryString;
#line 197 "../src/database.vala"
	_tmp84_ = strlen (_tmp83_);
#line 197 "../src/database.vala"
	_tmp85_ = _tmp84_;
#line 197 "../src/database.vala"
	_tmp87_ = sqlite3_prepare_v2 (_tmp81_, _tmp82_, _tmp85_, &_tmp86_, NULL);
#line 197 "../src/database.vala"
	_sqlite3_finalize0 (stmt);
#line 197 "../src/database.vala"
	stmt = _tmp86_;
#line 197 "../src/database.vala"
	bookworm_app_db_executionStatus = _tmp87_;
#line 198 "../src/database.vala"
	if (bookworm_app_db_executionStatus != SQLITE_OK) {
#line 1350 "database.c"
		const gchar* _tmp88_;
		sqlite3* _tmp89_;
		sqlite3* _tmp90_;
		const gchar* _tmp91_;
#line 199 "../src/database.vala"
		_tmp88_ = bookworm_app_db_queryString;
#line 199 "../src/database.vala"
		_tmp89_ = bookworm_app_db_bookwormDB;
#line 199 "../src/database.vala"
		_tmp90_ = bookworm_app_db_bookwormDB;
#line 199 "../src/database.vala"
		_tmp91_ = sqlite3_errmsg (_tmp90_);
#line 199 "../src/database.vala"
		bookworm_app_db_report_query_execution_error (_tmp88_, sqlite3_errcode (_tmp89_), _tmp91_);
#line 1365 "database.c"
	} else {
		sqlite3_stmt* _tmp243_;
#line 201 "../src/database.vala"
		while (TRUE) {
#line 1370 "database.c"
			sqlite3_stmt* _tmp92_;
			BookwormAppBook* aBook = NULL;
			BookwormAppBook* _tmp93_;
			BookwormAppBook* _tmp94_;
			sqlite3_stmt* _tmp95_;
			BookwormAppBook* _tmp96_;
			sqlite3_stmt* _tmp97_;
			const gchar* _tmp98_;
			BookwormAppBook* _tmp99_;
			sqlite3_stmt* _tmp100_;
			const gchar* _tmp101_;
			BookwormAppBook* _tmp102_;
			sqlite3_stmt* _tmp103_;
			const gchar* _tmp104_;
			BookwormAppBook* _tmp105_;
			sqlite3_stmt* _tmp106_;
			const gchar* _tmp107_;
			gboolean _tmp108_ = FALSE;
			sqlite3_stmt* _tmp109_;
			const gchar* _tmp110_;
			BookwormAppBook* _tmp111_;
			BookwormAppBook* _tmp112_;
			sqlite3_stmt* _tmp113_;
			const gchar* _tmp114_;
			BookwormAppBook* _tmp115_;
			sqlite3_stmt* _tmp116_;
			const gchar* _tmp117_;
			BookwormAppBook* _tmp118_;
			sqlite3_stmt* _tmp119_;
			const gchar* _tmp120_;
			BookwormAppBook* _tmp121_;
			sqlite3_stmt* _tmp122_;
			const gchar* _tmp123_;
			BookwormAppBook* _tmp124_;
			sqlite3_stmt* _tmp125_;
			const gchar* _tmp126_;
			BookwormAppBook* _tmp127_;
			sqlite3_stmt* _tmp128_;
			const gchar* _tmp129_;
			BookwormAppBook* _tmp130_;
			sqlite3_stmt* _tmp131_;
			const gchar* _tmp132_;
			BookwormAppBook* _tmp133_;
			sqlite3_stmt* _tmp134_;
			const gchar* _tmp135_;
			BookwormAppBook* _tmp136_;
			sqlite3_stmt* _tmp137_;
			const gchar* _tmp138_;
			sqlite3_stmt* _tmp139_;
			gchar* _tmp140_;
			gchar* _tmp141_;
			gchar* _tmp142_;
			gchar* _tmp143_;
			gchar* _tmp144_;
			gchar* _tmp145_;
			sqlite3_stmt* _tmp146_;
			const gchar* _tmp147_;
			gchar* _tmp148_;
			gchar* _tmp149_;
			gchar* _tmp150_;
			gchar* _tmp151_;
			sqlite3_stmt* _tmp152_;
			const gchar* _tmp153_;
			gchar* _tmp154_;
			gchar* _tmp155_;
			gchar* _tmp156_;
			gchar* _tmp157_;
			sqlite3_stmt* _tmp158_;
			const gchar* _tmp159_;
			gchar* _tmp160_;
			gchar* _tmp161_;
			gchar* _tmp162_;
			gchar* _tmp163_;
			sqlite3_stmt* _tmp164_;
			const gchar* _tmp165_;
			gchar* _tmp166_;
			gchar* _tmp167_;
			gchar* _tmp168_;
			gchar* _tmp169_;
			sqlite3_stmt* _tmp170_;
			const gchar* _tmp171_;
			gchar* _tmp172_;
			gchar* _tmp173_;
			gchar* _tmp174_;
			gchar* _tmp175_;
			sqlite3_stmt* _tmp176_;
			const gchar* _tmp177_;
			gchar* _tmp178_;
			gchar* _tmp179_;
			gchar* _tmp180_;
			gchar* _tmp181_;
			sqlite3_stmt* _tmp182_;
			const gchar* _tmp183_;
			gchar* _tmp184_;
			gchar* _tmp185_;
			gchar* _tmp186_;
			gchar* _tmp187_;
			sqlite3_stmt* _tmp188_;
			const gchar* _tmp189_;
			gchar* _tmp190_;
			gchar* _tmp191_;
			gchar* _tmp192_;
			gchar* _tmp193_;
			sqlite3_stmt* _tmp194_;
			const gchar* _tmp195_;
			gchar* _tmp196_;
			gchar* _tmp197_;
			gchar* _tmp198_;
			gchar* _tmp199_;
			sqlite3_stmt* _tmp200_;
			const gchar* _tmp201_;
			gchar* _tmp202_;
			gchar* _tmp203_;
			gchar* _tmp204_;
			gchar* _tmp205_;
			sqlite3_stmt* _tmp206_;
			const gchar* _tmp207_;
			gchar* _tmp208_;
			gchar* _tmp209_;
			gchar* _tmp210_;
			gchar* _tmp211_;
			sqlite3_stmt* _tmp212_;
			const gchar* _tmp213_;
			gchar* _tmp214_;
			gchar* _tmp215_;
			gchar* _tmp216_;
			gchar* _tmp217_;
			sqlite3_stmt* _tmp218_;
			const gchar* _tmp219_;
			gchar* _tmp220_;
			gchar* _tmp221_;
			gchar* _tmp222_;
			gchar* _tmp223_;
			sqlite3_stmt* _tmp224_;
			const gchar* _tmp225_;
			gchar* _tmp226_;
			gchar* _tmp227_;
			GeeArrayList* _tmp228_;
			BookwormAppBook* _tmp229_;
			GString* _tmp230_;
			BookwormAppBook* _tmp231_;
			gchar* _tmp232_;
			gchar* _tmp233_;
			BookwormAppBook* _tmp234_;
			gchar* _tmp235_;
#line 201 "../src/database.vala"
			_tmp92_ = stmt;
#line 201 "../src/database.vala"
			if (!(sqlite3_step (_tmp92_) == SQLITE_ROW)) {
#line 201 "../src/database.vala"
				break;
#line 1522 "database.c"
			}
#line 202 "../src/database.vala"
			_tmp93_ = bookworm_app_book_new ();
#line 202 "../src/database.vala"
			aBook = _tmp93_;
#line 203 "../src/database.vala"
			_tmp94_ = aBook;
#line 203 "../src/database.vala"
			_tmp95_ = stmt;
#line 203 "../src/database.vala"
			bookworm_app_book_setBookId (_tmp94_, sqlite3_column_int (_tmp95_, 0));
#line 204 "../src/database.vala"
			_tmp96_ = aBook;
#line 204 "../src/database.vala"
			_tmp97_ = stmt;
#line 204 "../src/database.vala"
			_tmp98_ = (const gchar*) sqlite3_column_text (_tmp97_, 1);
#line 204 "../src/database.vala"
			bookworm_app_book_setBookLocation (_tmp96_, _tmp98_);
#line 205 "../src/database.vala"
			_tmp99_ = aBook;
#line 205 "../src/database.vala"
			_tmp100_ = stmt;
#line 205 "../src/database.vala"
			_tmp101_ = (const gchar*) sqlite3_column_text (_tmp100_, 2);
#line 205 "../src/database.vala"
			bookworm_app_book_setBookTitle (_tmp99_, _tmp101_);
#line 206 "../src/database.vala"
			_tmp102_ = aBook;
#line 206 "../src/database.vala"
			_tmp103_ = stmt;
#line 206 "../src/database.vala"
			_tmp104_ = (const gchar*) sqlite3_column_text (_tmp103_, 3);
#line 206 "../src/database.vala"
			bookworm_app_book_setBookAuthor (_tmp102_, _tmp104_);
#line 207 "../src/database.vala"
			_tmp105_ = aBook;
#line 207 "../src/database.vala"
			_tmp106_ = stmt;
#line 207 "../src/database.vala"
			_tmp107_ = (const gchar*) sqlite3_column_text (_tmp106_, 4);
#line 207 "../src/database.vala"
			bookworm_app_book_setBookCoverLocation (_tmp105_, _tmp107_);
#line 208 "../src/database.vala"
			_tmp109_ = stmt;
#line 208 "../src/database.vala"
			_tmp110_ = (const gchar*) sqlite3_column_text (_tmp109_, 5);
#line 208 "../src/database.vala"
			if (g_strcmp0 (_tmp110_, "true") == 0) {
#line 208 "../src/database.vala"
				_tmp108_ = TRUE;
#line 1574 "database.c"
			} else {
#line 208 "../src/database.vala"
				_tmp108_ = FALSE;
#line 1578 "database.c"
			}
#line 208 "../src/database.vala"
			_tmp111_ = aBook;
#line 208 "../src/database.vala"
			bookworm_app_book_setIsBookCoverImagePresent (_tmp111_, _tmp108_);
#line 209 "../src/database.vala"
			_tmp112_ = aBook;
#line 209 "../src/database.vala"
			_tmp113_ = stmt;
#line 209 "../src/database.vala"
			_tmp114_ = (const gchar*) sqlite3_column_text (_tmp113_, 6);
#line 209 "../src/database.vala"
			bookworm_app_book_setBookPageNumber (_tmp112_, atoi (_tmp114_));
#line 210 "../src/database.vala"
			_tmp115_ = aBook;
#line 210 "../src/database.vala"
			_tmp116_ = stmt;
#line 210 "../src/database.vala"
			_tmp117_ = (const gchar*) sqlite3_column_text (_tmp116_, 7);
#line 210 "../src/database.vala"
			bookworm_app_book_setBookPublishDate (_tmp115_, _tmp117_);
#line 211 "../src/database.vala"
			_tmp118_ = aBook;
#line 211 "../src/database.vala"
			_tmp119_ = stmt;
#line 211 "../src/database.vala"
			_tmp120_ = (const gchar*) sqlite3_column_text (_tmp119_, 8);
#line 211 "../src/database.vala"
			bookworm_app_book_setBookTags (_tmp118_, _tmp120_);
#line 212 "../src/database.vala"
			_tmp121_ = aBook;
#line 212 "../src/database.vala"
			_tmp122_ = stmt;
#line 212 "../src/database.vala"
			_tmp123_ = (const gchar*) sqlite3_column_text (_tmp122_, 9);
#line 212 "../src/database.vala"
			bookworm_app_book_setAnnotationTags (_tmp121_, _tmp123_);
#line 213 "../src/database.vala"
			_tmp124_ = aBook;
#line 213 "../src/database.vala"
			_tmp125_ = stmt;
#line 213 "../src/database.vala"
			_tmp126_ = (const gchar*) sqlite3_column_text (_tmp125_, 10);
#line 213 "../src/database.vala"
			bookworm_app_book_setBookRating (_tmp124_, atoi (_tmp126_));
#line 214 "../src/database.vala"
			_tmp127_ = aBook;
#line 214 "../src/database.vala"
			_tmp128_ = stmt;
#line 214 "../src/database.vala"
			_tmp129_ = (const gchar*) sqlite3_column_text (_tmp128_, 11);
#line 214 "../src/database.vala"
			bookworm_app_book_setBookExtractionLocation (_tmp127_, _tmp129_);
#line 215 "../src/database.vala"
			_tmp130_ = aBook;
#line 215 "../src/database.vala"
			_tmp131_ = stmt;
#line 215 "../src/database.vala"
			_tmp132_ = (const gchar*) sqlite3_column_text (_tmp131_, 12);
#line 215 "../src/database.vala"
			bookworm_app_book_setBookTotalPages (_tmp130_, atoi (_tmp132_));
#line 216 "../src/database.vala"
			_tmp133_ = aBook;
#line 216 "../src/database.vala"
			_tmp134_ = stmt;
#line 216 "../src/database.vala"
			_tmp135_ = (const gchar*) sqlite3_column_text (_tmp134_, 13);
#line 216 "../src/database.vala"
			bookworm_app_book_setBookCreationDate (_tmp133_, _tmp135_);
#line 217 "../src/database.vala"
			_tmp136_ = aBook;
#line 217 "../src/database.vala"
			_tmp137_ = stmt;
#line 217 "../src/database.vala"
			_tmp138_ = (const gchar*) sqlite3_column_text (_tmp137_, 14);
#line 217 "../src/database.vala"
			bookworm_app_book_setBookLastModificationDate (_tmp136_, _tmp138_);
#line 218 "../src/database.vala"
			_tmp139_ = stmt;
#line 218 "../src/database.vala"
			_tmp140_ = g_strdup_printf ("%i", sqlite3_column_int (_tmp139_, 0));
#line 218 "../src/database.vala"
			_tmp141_ = _tmp140_;
#line 218 "../src/database.vala"
			_tmp142_ = g_strconcat ("Book details fetched from DB: id=", _tmp141_, NULL);
#line 218 "../src/database.vala"
			_tmp143_ = _tmp142_;
#line 218 "../src/database.vala"
			_tmp144_ = g_strconcat (_tmp143_, ",BOOK_LOCATION=", NULL);
#line 218 "../src/database.vala"
			_tmp145_ = _tmp144_;
#line 218 "../src/database.vala"
			_tmp146_ = stmt;
#line 218 "../src/database.vala"
			_tmp147_ = (const gchar*) sqlite3_column_text (_tmp146_, 1);
#line 218 "../src/database.vala"
			_tmp148_ = g_strconcat (_tmp145_, _tmp147_, NULL);
#line 218 "../src/database.vala"
			_tmp149_ = _tmp148_;
#line 218 "../src/database.vala"
			_tmp150_ = g_strconcat (_tmp149_, ",BOOK_TITLE=", NULL);
#line 218 "../src/database.vala"
			_tmp151_ = _tmp150_;
#line 218 "../src/database.vala"
			_tmp152_ = stmt;
#line 218 "../src/database.vala"
			_tmp153_ = (const gchar*) sqlite3_column_text (_tmp152_, 2);
#line 218 "../src/database.vala"
			_tmp154_ = g_strconcat (_tmp151_, _tmp153_, NULL);
#line 218 "../src/database.vala"
			_tmp155_ = _tmp154_;
#line 218 "../src/database.vala"
			_tmp156_ = g_strconcat (_tmp155_, ",BOOK_AUTHOR=", NULL);
#line 218 "../src/database.vala"
			_tmp157_ = _tmp156_;
#line 218 "../src/database.vala"
			_tmp158_ = stmt;
#line 218 "../src/database.vala"
			_tmp159_ = (const gchar*) sqlite3_column_text (_tmp158_, 3);
#line 218 "../src/database.vala"
			_tmp160_ = g_strconcat (_tmp157_, _tmp159_, NULL);
#line 218 "../src/database.vala"
			_tmp161_ = _tmp160_;
#line 218 "../src/database.vala"
			_tmp162_ = g_strconcat (_tmp161_, ",BOOK_COVER_IMAGE_LOCATION=", NULL);
#line 218 "../src/database.vala"
			_tmp163_ = _tmp162_;
#line 218 "../src/database.vala"
			_tmp164_ = stmt;
#line 218 "../src/database.vala"
			_tmp165_ = (const gchar*) sqlite3_column_text (_tmp164_, 4);
#line 218 "../src/database.vala"
			_tmp166_ = g_strconcat (_tmp163_, _tmp165_, NULL);
#line 218 "../src/database.vala"
			_tmp167_ = _tmp166_;
#line 218 "../src/database.vala"
			_tmp168_ = g_strconcat (_tmp167_, ",IS_BOOK_COVER_IMAGE_PRESENT=", NULL);
#line 218 "../src/database.vala"
			_tmp169_ = _tmp168_;
#line 218 "../src/database.vala"
			_tmp170_ = stmt;
#line 218 "../src/database.vala"
			_tmp171_ = (const gchar*) sqlite3_column_text (_tmp170_, 5);
#line 218 "../src/database.vala"
			_tmp172_ = g_strconcat (_tmp169_, _tmp171_, NULL);
#line 218 "../src/database.vala"
			_tmp173_ = _tmp172_;
#line 218 "../src/database.vala"
			_tmp174_ = g_strconcat (_tmp173_, ",BOOK_LAST_READ_PAGE_NUMBER=", NULL);
#line 218 "../src/database.vala"
			_tmp175_ = _tmp174_;
#line 218 "../src/database.vala"
			_tmp176_ = stmt;
#line 218 "../src/database.vala"
			_tmp177_ = (const gchar*) sqlite3_column_text (_tmp176_, 6);
#line 218 "../src/database.vala"
			_tmp178_ = g_strconcat (_tmp175_, _tmp177_, NULL);
#line 218 "../src/database.vala"
			_tmp179_ = _tmp178_;
#line 218 "../src/database.vala"
			_tmp180_ = g_strconcat (_tmp179_, ",BOOK_PUBLISH_DATE=", NULL);
#line 218 "../src/database.vala"
			_tmp181_ = _tmp180_;
#line 218 "../src/database.vala"
			_tmp182_ = stmt;
#line 218 "../src/database.vala"
			_tmp183_ = (const gchar*) sqlite3_column_text (_tmp182_, 7);
#line 218 "../src/database.vala"
			_tmp184_ = g_strconcat (_tmp181_, _tmp183_, NULL);
#line 218 "../src/database.vala"
			_tmp185_ = _tmp184_;
#line 218 "../src/database.vala"
			_tmp186_ = g_strconcat (_tmp185_, ",TAGS=", NULL);
#line 218 "../src/database.vala"
			_tmp187_ = _tmp186_;
#line 218 "../src/database.vala"
			_tmp188_ = stmt;
#line 218 "../src/database.vala"
			_tmp189_ = (const gchar*) sqlite3_column_text (_tmp188_, 8);
#line 218 "../src/database.vala"
			_tmp190_ = g_strconcat (_tmp187_, _tmp189_, NULL);
#line 218 "../src/database.vala"
			_tmp191_ = _tmp190_;
#line 218 "../src/database.vala"
			_tmp192_ = g_strconcat (_tmp191_, ",ANNOTATION_TAGS=", NULL);
#line 218 "../src/database.vala"
			_tmp193_ = _tmp192_;
#line 218 "../src/database.vala"
			_tmp194_ = stmt;
#line 218 "../src/database.vala"
			_tmp195_ = (const gchar*) sqlite3_column_text (_tmp194_, 9);
#line 218 "../src/database.vala"
			_tmp196_ = g_strconcat (_tmp193_, _tmp195_, NULL);
#line 218 "../src/database.vala"
			_tmp197_ = _tmp196_;
#line 218 "../src/database.vala"
			_tmp198_ = g_strconcat (_tmp197_, ",RATINGS=", NULL);
#line 218 "../src/database.vala"
			_tmp199_ = _tmp198_;
#line 218 "../src/database.vala"
			_tmp200_ = stmt;
#line 218 "../src/database.vala"
			_tmp201_ = (const gchar*) sqlite3_column_text (_tmp200_, 10);
#line 218 "../src/database.vala"
			_tmp202_ = g_strconcat (_tmp199_, _tmp201_, NULL);
#line 218 "../src/database.vala"
			_tmp203_ = _tmp202_;
#line 218 "../src/database.vala"
			_tmp204_ = g_strconcat (_tmp203_, ",CONTENT_EXTRACTION_LOCATION=", NULL);
#line 218 "../src/database.vala"
			_tmp205_ = _tmp204_;
#line 218 "../src/database.vala"
			_tmp206_ = stmt;
#line 218 "../src/database.vala"
			_tmp207_ = (const gchar*) sqlite3_column_text (_tmp206_, 11);
#line 218 "../src/database.vala"
			_tmp208_ = g_strconcat (_tmp205_, _tmp207_, NULL);
#line 218 "../src/database.vala"
			_tmp209_ = _tmp208_;
#line 218 "../src/database.vala"
			_tmp210_ = g_strconcat (_tmp209_, ",BOOK_TOTAL_PAGES=", NULL);
#line 218 "../src/database.vala"
			_tmp211_ = _tmp210_;
#line 218 "../src/database.vala"
			_tmp212_ = stmt;
#line 218 "../src/database.vala"
			_tmp213_ = (const gchar*) sqlite3_column_text (_tmp212_, 12);
#line 218 "../src/database.vala"
			_tmp214_ = g_strconcat (_tmp211_, _tmp213_, NULL);
#line 218 "../src/database.vala"
			_tmp215_ = _tmp214_;
#line 218 "../src/database.vala"
			_tmp216_ = g_strconcat (_tmp215_, ",creation_date=", NULL);
#line 218 "../src/database.vala"
			_tmp217_ = _tmp216_;
#line 218 "../src/database.vala"
			_tmp218_ = stmt;
#line 218 "../src/database.vala"
			_tmp219_ = (const gchar*) sqlite3_column_text (_tmp218_, 13);
#line 218 "../src/database.vala"
			_tmp220_ = g_strconcat (_tmp217_, _tmp219_, NULL);
#line 218 "../src/database.vala"
			_tmp221_ = _tmp220_;
#line 218 "../src/database.vala"
			_tmp222_ = g_strconcat (_tmp221_, ",modification_date=", NULL);
#line 218 "../src/database.vala"
			_tmp223_ = _tmp222_;
#line 218 "../src/database.vala"
			_tmp224_ = stmt;
#line 218 "../src/database.vala"
			_tmp225_ = (const gchar*) sqlite3_column_text (_tmp224_, 14);
#line 218 "../src/database.vala"
			_tmp226_ = g_strconcat (_tmp223_, _tmp225_, NULL);
#line 218 "../src/database.vala"
			_tmp227_ = _tmp226_;
#line 218 "../src/database.vala"
			g_debug ("database.vala:218: %s", _tmp227_);
#line 218 "../src/database.vala"
			_g_free0 (_tmp227_);
#line 218 "../src/database.vala"
			_g_free0 (_tmp223_);
#line 218 "../src/database.vala"
			_g_free0 (_tmp221_);
#line 218 "../src/database.vala"
			_g_free0 (_tmp217_);
#line 218 "../src/database.vala"
			_g_free0 (_tmp215_);
#line 218 "../src/database.vala"
			_g_free0 (_tmp211_);
#line 218 "../src/database.vala"
			_g_free0 (_tmp209_);
#line 218 "../src/database.vala"
			_g_free0 (_tmp205_);
#line 218 "../src/database.vala"
			_g_free0 (_tmp203_);
#line 218 "../src/database.vala"
			_g_free0 (_tmp199_);
#line 218 "../src/database.vala"
			_g_free0 (_tmp197_);
#line 218 "../src/database.vala"
			_g_free0 (_tmp193_);
#line 218 "../src/database.vala"
			_g_free0 (_tmp191_);
#line 218 "../src/database.vala"
			_g_free0 (_tmp187_);
#line 218 "../src/database.vala"
			_g_free0 (_tmp185_);
#line 218 "../src/database.vala"
			_g_free0 (_tmp181_);
#line 218 "../src/database.vala"
			_g_free0 (_tmp179_);
#line 218 "../src/database.vala"
			_g_free0 (_tmp175_);
#line 218 "../src/database.vala"
			_g_free0 (_tmp173_);
#line 218 "../src/database.vala"
			_g_free0 (_tmp169_);
#line 218 "../src/database.vala"
			_g_free0 (_tmp167_);
#line 218 "../src/database.vala"
			_g_free0 (_tmp163_);
#line 218 "../src/database.vala"
			_g_free0 (_tmp161_);
#line 218 "../src/database.vala"
			_g_free0 (_tmp157_);
#line 218 "../src/database.vala"
			_g_free0 (_tmp155_);
#line 218 "../src/database.vala"
			_g_free0 (_tmp151_);
#line 218 "../src/database.vala"
			_g_free0 (_tmp149_);
#line 218 "../src/database.vala"
			_g_free0 (_tmp145_);
#line 218 "../src/database.vala"
			_g_free0 (_tmp143_);
#line 218 "../src/database.vala"
			_g_free0 (_tmp141_);
#line 234 "../src/database.vala"
			_tmp228_ = listOfBooks;
#line 234 "../src/database.vala"
			_tmp229_ = aBook;
#line 234 "../src/database.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp228_, _tmp229_);
#line 236 "../src/database.vala"
			_tmp230_ = bookworm_app_bookworm_pathsOfBooksInLibraryOnLoadStr;
#line 236 "../src/database.vala"
			_tmp231_ = aBook;
#line 236 "../src/database.vala"
			_tmp232_ = bookworm_app_book_getBookLocation (_tmp231_);
#line 236 "../src/database.vala"
			_tmp233_ = _tmp232_;
#line 236 "../src/database.vala"
			g_string_append (_tmp230_, _tmp233_);
#line 236 "../src/database.vala"
			_g_free0 (_tmp233_);
#line 238 "../src/database.vala"
			_tmp234_ = aBook;
#line 238 "../src/database.vala"
			_tmp235_ = bookworm_app_book_getBookLastModificationDate (_tmp234_);
#line 238 "../src/database.vala"
			_g_free0 (last_modification_date);
#line 238 "../src/database.vala"
			last_modification_date = _tmp235_;
#line 201 "../src/database.vala"
			_bookworm_app_book_unref0 (aBook);
#line 1924 "database.c"
		}
#line 240 "../src/database.vala"
		if (g_strcmp0 (mode, "PAGINATED_SEARCH") == 0) {
#line 1928 "database.c"
			GeeArrayList* _tmp236_;
			gint _tmp237_;
			gint _tmp238_;
			const gchar* _tmp239_;
#line 242 "../src/database.vala"
			_tmp236_ = listOfBooks;
#line 242 "../src/database.vala"
			_tmp237_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp236_);
#line 242 "../src/database.vala"
			_tmp238_ = _tmp237_;
#line 242 "../src/database.vala"
			_tmp239_ = bookworm_app_bookworm_no_of_books_per_page;
#line 242 "../src/database.vala"
			if (_tmp238_ == atoi (_tmp239_)) {
#line 1943 "database.c"
				GeeArrayList* _tmp240_;
				const gchar* _tmp241_;
#line 244 "../src/database.vala"
				_tmp240_ = bookworm_app_bookworm_paginationlist;
#line 244 "../src/database.vala"
				_tmp241_ = last_modification_date;
#line 244 "../src/database.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp240_, _tmp241_);
#line 1952 "database.c"
			} else {
				GeeArrayList* _tmp242_;
#line 246 "../src/database.vala"
				_tmp242_ = bookworm_app_bookworm_paginationlist;
#line 246 "../src/database.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp242_, "-1");
#line 1959 "database.c"
			}
		}
#line 249 "../src/database.vala"
		_tmp243_ = stmt;
#line 249 "../src/database.vala"
		sqlite3_reset (_tmp243_);
#line 1966 "database.c"
	}
#line 251 "../src/database.vala"
	_tmp244_ = listOfBooks;
#line 251 "../src/database.vala"
	_tmp245_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp244_);
#line 251 "../src/database.vala"
	_tmp246_ = _tmp245_;
#line 251 "../src/database.vala"
	_tmp247_ = g_strdup_printf ("%i", _tmp246_);
#line 251 "../src/database.vala"
	_tmp248_ = _tmp247_;
#line 251 "../src/database.vala"
	_tmp249_ = g_strconcat ("[END] [FUNCTION:getBooksFromDB] no. of books fetched [", _tmp248_, NULL);
#line 251 "../src/database.vala"
	_tmp250_ = _tmp249_;
#line 251 "../src/database.vala"
	_tmp251_ = g_strconcat (_tmp250_, "], last_modification_date of books fetched[", NULL);
#line 251 "../src/database.vala"
	_tmp252_ = _tmp251_;
#line 251 "../src/database.vala"
	_tmp253_ = last_modification_date;
#line 251 "../src/database.vala"
	_tmp254_ = g_strconcat (_tmp252_, _tmp253_, NULL);
#line 251 "../src/database.vala"
	_tmp255_ = _tmp254_;
#line 251 "../src/database.vala"
	_tmp256_ = g_strconcat (_tmp255_, "]", NULL);
#line 251 "../src/database.vala"
	_tmp257_ = _tmp256_;
#line 251 "../src/database.vala"
	g_info ("database.vala:251: %s", _tmp257_);
#line 251 "../src/database.vala"
	_g_free0 (_tmp257_);
#line 251 "../src/database.vala"
	_g_free0 (_tmp255_);
#line 251 "../src/database.vala"
	_g_free0 (_tmp252_);
#line 251 "../src/database.vala"
	_g_free0 (_tmp250_);
#line 251 "../src/database.vala"
	_g_free0 (_tmp248_);
#line 252 "../src/database.vala"
	result = listOfBooks;
#line 252 "../src/database.vala"
	_g_free0 (last_modification_date);
#line 252 "../src/database.vala"
	_sqlite3_finalize0 (stmt);
#line 252 "../src/database.vala"
	return result;
#line 2016 "database.c"
}

BookwormAppBook*
bookworm_app_db_getBookFromDB (const gchar* book_location)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	sqlite3_stmt* stmt = NULL;
	BookwormAppBook* aBook = NULL;
	BookwormAppBook* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	sqlite3* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	sqlite3_stmt* _tmp24_ = NULL;
	gint _tmp25_;
	sqlite3_stmt* _tmp165_;
	BookwormAppBook* _tmp166_;
	gchar* _tmp167_;
	gchar* _tmp168_;
	gchar* _tmp169_;
	gchar* _tmp170_;
	gchar* _tmp171_;
	gchar* _tmp172_;
	BookwormAppBook* result = NULL;
#line 255 "../src/database.vala"
	g_return_val_if_fail (book_location != NULL, NULL);
#line 256 "../src/database.vala"
	_tmp0_ = g_strconcat ("[START] [FUNCTION:getBookFromDB] Attempting to search DB for book.loca" \
"tion=", book_location, NULL);
#line 256 "../src/database.vala"
	_tmp1_ = _tmp0_;
#line 256 "../src/database.vala"
	g_info ("database.vala:256: %s", _tmp1_);
#line 256 "../src/database.vala"
	_g_free0 (_tmp1_);
#line 258 "../src/database.vala"
	_tmp2_ = bookworm_app_book_new ();
#line 258 "../src/database.vala"
	aBook = _tmp2_;
#line 259 "../src/database.vala"
	_tmp3_ = g_strdup ("SELECT id, BOOK_LOCATION, BOOK_TITLE, BOOK_AUTHOR, BOOK_COVER_IMAGE_LO" \
"CATION, " "IS_BOOK_COVER_IMAGE_PRESENT, BOOK_LAST_READ_PAGE_NUMBER, BOOK_PUBLISH_" \
"DATE, TAGS, " "ANNOTATION_TAGS, RATINGS, CONTENT_EXTRACTION_LOCATION, BOOK_TOTAL_PAGE" \
"S, creation_date, " "modification_date FROM " BOOKWORM_APP_DB_BOOKWORM_TABLE_NAME);
#line 259 "../src/database.vala"
	_g_free0 (bookworm_app_db_queryString);
#line 259 "../src/database.vala"
	bookworm_app_db_queryString = _tmp3_;
#line 264 "../src/database.vala"
	_tmp4_ = bookworm_app_db_queryString;
#line 264 "../src/database.vala"
	_tmp5_ = g_strconcat (_tmp4_, " WHERE ", NULL);
#line 264 "../src/database.vala"
	_tmp6_ = _tmp5_;
#line 264 "../src/database.vala"
	_tmp7_ = g_strconcat (_tmp6_, " BOOK_LOCATION LIKE '", NULL);
#line 264 "../src/database.vala"
	_tmp8_ = _tmp7_;
#line 264 "../src/database.vala"
	_tmp9_ = g_strconcat (_tmp8_, book_location, NULL);
#line 264 "../src/database.vala"
	_tmp10_ = _tmp9_;
#line 264 "../src/database.vala"
	_tmp11_ = g_strconcat (_tmp10_, "'", NULL);
#line 264 "../src/database.vala"
	_g_free0 (bookworm_app_db_queryString);
#line 264 "../src/database.vala"
	bookworm_app_db_queryString = _tmp11_;
#line 264 "../src/database.vala"
	_g_free0 (_tmp10_);
#line 264 "../src/database.vala"
	_g_free0 (_tmp8_);
#line 264 "../src/database.vala"
	_g_free0 (_tmp6_);
#line 265 "../src/database.vala"
	_tmp12_ = g_strconcat ("Library Search Query with criteria[", book_location, NULL);
#line 265 "../src/database.vala"
	_tmp13_ = _tmp12_;
#line 265 "../src/database.vala"
	_tmp14_ = g_strconcat (_tmp13_, "]:", NULL);
#line 265 "../src/database.vala"
	_tmp15_ = _tmp14_;
#line 265 "../src/database.vala"
	_tmp16_ = bookworm_app_db_queryString;
#line 265 "../src/database.vala"
	_tmp17_ = g_strconcat (_tmp15_, _tmp16_, NULL);
#line 265 "../src/database.vala"
	_tmp18_ = _tmp17_;
#line 265 "../src/database.vala"
	g_debug ("database.vala:265: %s", _tmp18_);
#line 265 "../src/database.vala"
	_g_free0 (_tmp18_);
#line 265 "../src/database.vala"
	_g_free0 (_tmp15_);
#line 265 "../src/database.vala"
	_g_free0 (_tmp13_);
#line 266 "../src/database.vala"
	_tmp19_ = bookworm_app_db_bookwormDB;
#line 266 "../src/database.vala"
	_tmp20_ = bookworm_app_db_queryString;
#line 266 "../src/database.vala"
	_tmp21_ = bookworm_app_db_queryString;
#line 266 "../src/database.vala"
	_tmp22_ = strlen (_tmp21_);
#line 266 "../src/database.vala"
	_tmp23_ = _tmp22_;
#line 266 "../src/database.vala"
	_tmp25_ = sqlite3_prepare_v2 (_tmp19_, _tmp20_, _tmp23_, &_tmp24_, NULL);
#line 266 "../src/database.vala"
	_sqlite3_finalize0 (stmt);
#line 266 "../src/database.vala"
	stmt = _tmp24_;
#line 266 "../src/database.vala"
	bookworm_app_db_executionStatus = _tmp25_;
#line 267 "../src/database.vala"
	if (bookworm_app_db_executionStatus != SQLITE_OK) {
#line 2147 "database.c"
		const gchar* _tmp26_;
		sqlite3* _tmp27_;
		sqlite3* _tmp28_;
		const gchar* _tmp29_;
#line 268 "../src/database.vala"
		_tmp26_ = bookworm_app_db_queryString;
#line 268 "../src/database.vala"
		_tmp27_ = bookworm_app_db_bookwormDB;
#line 268 "../src/database.vala"
		_tmp28_ = bookworm_app_db_bookwormDB;
#line 268 "../src/database.vala"
		_tmp29_ = sqlite3_errmsg (_tmp28_);
#line 268 "../src/database.vala"
		bookworm_app_db_report_query_execution_error (_tmp26_, sqlite3_errcode (_tmp27_), _tmp29_);
#line 2162 "database.c"
	} else {
#line 270 "../src/database.vala"
		while (TRUE) {
#line 2166 "database.c"
			sqlite3_stmt* _tmp30_;
			BookwormAppBook* _tmp31_;
			sqlite3_stmt* _tmp32_;
			BookwormAppBook* _tmp33_;
			sqlite3_stmt* _tmp34_;
			const gchar* _tmp35_;
			BookwormAppBook* _tmp36_;
			sqlite3_stmt* _tmp37_;
			const gchar* _tmp38_;
			BookwormAppBook* _tmp39_;
			sqlite3_stmt* _tmp40_;
			const gchar* _tmp41_;
			BookwormAppBook* _tmp42_;
			sqlite3_stmt* _tmp43_;
			const gchar* _tmp44_;
			gboolean _tmp45_ = FALSE;
			sqlite3_stmt* _tmp46_;
			const gchar* _tmp47_;
			BookwormAppBook* _tmp48_;
			BookwormAppBook* _tmp49_;
			sqlite3_stmt* _tmp50_;
			const gchar* _tmp51_;
			BookwormAppBook* _tmp52_;
			sqlite3_stmt* _tmp53_;
			const gchar* _tmp54_;
			BookwormAppBook* _tmp55_;
			sqlite3_stmt* _tmp56_;
			const gchar* _tmp57_;
			BookwormAppBook* _tmp58_;
			sqlite3_stmt* _tmp59_;
			const gchar* _tmp60_;
			BookwormAppBook* _tmp61_;
			sqlite3_stmt* _tmp62_;
			const gchar* _tmp63_;
			BookwormAppBook* _tmp64_;
			sqlite3_stmt* _tmp65_;
			const gchar* _tmp66_;
			BookwormAppBook* _tmp67_;
			sqlite3_stmt* _tmp68_;
			const gchar* _tmp69_;
			BookwormAppBook* _tmp70_;
			sqlite3_stmt* _tmp71_;
			const gchar* _tmp72_;
			BookwormAppBook* _tmp73_;
			sqlite3_stmt* _tmp74_;
			const gchar* _tmp75_;
			sqlite3_stmt* _tmp76_;
			gchar* _tmp77_;
			gchar* _tmp78_;
			gchar* _tmp79_;
			gchar* _tmp80_;
			gchar* _tmp81_;
			gchar* _tmp82_;
			sqlite3_stmt* _tmp83_;
			const gchar* _tmp84_;
			gchar* _tmp85_;
			gchar* _tmp86_;
			gchar* _tmp87_;
			gchar* _tmp88_;
			sqlite3_stmt* _tmp89_;
			const gchar* _tmp90_;
			gchar* _tmp91_;
			gchar* _tmp92_;
			gchar* _tmp93_;
			gchar* _tmp94_;
			sqlite3_stmt* _tmp95_;
			const gchar* _tmp96_;
			gchar* _tmp97_;
			gchar* _tmp98_;
			gchar* _tmp99_;
			gchar* _tmp100_;
			sqlite3_stmt* _tmp101_;
			const gchar* _tmp102_;
			gchar* _tmp103_;
			gchar* _tmp104_;
			gchar* _tmp105_;
			gchar* _tmp106_;
			sqlite3_stmt* _tmp107_;
			const gchar* _tmp108_;
			gchar* _tmp109_;
			gchar* _tmp110_;
			gchar* _tmp111_;
			gchar* _tmp112_;
			sqlite3_stmt* _tmp113_;
			const gchar* _tmp114_;
			gchar* _tmp115_;
			gchar* _tmp116_;
			gchar* _tmp117_;
			gchar* _tmp118_;
			sqlite3_stmt* _tmp119_;
			const gchar* _tmp120_;
			gchar* _tmp121_;
			gchar* _tmp122_;
			gchar* _tmp123_;
			gchar* _tmp124_;
			sqlite3_stmt* _tmp125_;
			const gchar* _tmp126_;
			gchar* _tmp127_;
			gchar* _tmp128_;
			gchar* _tmp129_;
			gchar* _tmp130_;
			sqlite3_stmt* _tmp131_;
			const gchar* _tmp132_;
			gchar* _tmp133_;
			gchar* _tmp134_;
			gchar* _tmp135_;
			gchar* _tmp136_;
			sqlite3_stmt* _tmp137_;
			const gchar* _tmp138_;
			gchar* _tmp139_;
			gchar* _tmp140_;
			gchar* _tmp141_;
			gchar* _tmp142_;
			sqlite3_stmt* _tmp143_;
			const gchar* _tmp144_;
			gchar* _tmp145_;
			gchar* _tmp146_;
			gchar* _tmp147_;
			gchar* _tmp148_;
			sqlite3_stmt* _tmp149_;
			const gchar* _tmp150_;
			gchar* _tmp151_;
			gchar* _tmp152_;
			gchar* _tmp153_;
			gchar* _tmp154_;
			sqlite3_stmt* _tmp155_;
			const gchar* _tmp156_;
			gchar* _tmp157_;
			gchar* _tmp158_;
			gchar* _tmp159_;
			gchar* _tmp160_;
			sqlite3_stmt* _tmp161_;
			const gchar* _tmp162_;
			gchar* _tmp163_;
			gchar* _tmp164_;
#line 270 "../src/database.vala"
			_tmp30_ = stmt;
#line 270 "../src/database.vala"
			if (!(sqlite3_step (_tmp30_) == SQLITE_ROW)) {
#line 270 "../src/database.vala"
				break;
#line 2308 "database.c"
			}
#line 271 "../src/database.vala"
			_tmp31_ = aBook;
#line 271 "../src/database.vala"
			_tmp32_ = stmt;
#line 271 "../src/database.vala"
			bookworm_app_book_setBookId (_tmp31_, sqlite3_column_int (_tmp32_, 0));
#line 272 "../src/database.vala"
			_tmp33_ = aBook;
#line 272 "../src/database.vala"
			_tmp34_ = stmt;
#line 272 "../src/database.vala"
			_tmp35_ = (const gchar*) sqlite3_column_text (_tmp34_, 1);
#line 272 "../src/database.vala"
			bookworm_app_book_setBookLocation (_tmp33_, _tmp35_);
#line 273 "../src/database.vala"
			_tmp36_ = aBook;
#line 273 "../src/database.vala"
			_tmp37_ = stmt;
#line 273 "../src/database.vala"
			_tmp38_ = (const gchar*) sqlite3_column_text (_tmp37_, 2);
#line 273 "../src/database.vala"
			bookworm_app_book_setBookTitle (_tmp36_, _tmp38_);
#line 274 "../src/database.vala"
			_tmp39_ = aBook;
#line 274 "../src/database.vala"
			_tmp40_ = stmt;
#line 274 "../src/database.vala"
			_tmp41_ = (const gchar*) sqlite3_column_text (_tmp40_, 3);
#line 274 "../src/database.vala"
			bookworm_app_book_setBookAuthor (_tmp39_, _tmp41_);
#line 275 "../src/database.vala"
			_tmp42_ = aBook;
#line 275 "../src/database.vala"
			_tmp43_ = stmt;
#line 275 "../src/database.vala"
			_tmp44_ = (const gchar*) sqlite3_column_text (_tmp43_, 4);
#line 275 "../src/database.vala"
			bookworm_app_book_setBookCoverLocation (_tmp42_, _tmp44_);
#line 276 "../src/database.vala"
			_tmp46_ = stmt;
#line 276 "../src/database.vala"
			_tmp47_ = (const gchar*) sqlite3_column_text (_tmp46_, 5);
#line 276 "../src/database.vala"
			if (g_strcmp0 (_tmp47_, "true") == 0) {
#line 276 "../src/database.vala"
				_tmp45_ = TRUE;
#line 2356 "database.c"
			} else {
#line 276 "../src/database.vala"
				_tmp45_ = FALSE;
#line 2360 "database.c"
			}
#line 276 "../src/database.vala"
			_tmp48_ = aBook;
#line 276 "../src/database.vala"
			bookworm_app_book_setIsBookCoverImagePresent (_tmp48_, _tmp45_);
#line 277 "../src/database.vala"
			_tmp49_ = aBook;
#line 277 "../src/database.vala"
			_tmp50_ = stmt;
#line 277 "../src/database.vala"
			_tmp51_ = (const gchar*) sqlite3_column_text (_tmp50_, 6);
#line 277 "../src/database.vala"
			bookworm_app_book_setBookPageNumber (_tmp49_, atoi (_tmp51_));
#line 278 "../src/database.vala"
			_tmp52_ = aBook;
#line 278 "../src/database.vala"
			_tmp53_ = stmt;
#line 278 "../src/database.vala"
			_tmp54_ = (const gchar*) sqlite3_column_text (_tmp53_, 7);
#line 278 "../src/database.vala"
			bookworm_app_book_setBookPublishDate (_tmp52_, _tmp54_);
#line 279 "../src/database.vala"
			_tmp55_ = aBook;
#line 279 "../src/database.vala"
			_tmp56_ = stmt;
#line 279 "../src/database.vala"
			_tmp57_ = (const gchar*) sqlite3_column_text (_tmp56_, 8);
#line 279 "../src/database.vala"
			bookworm_app_book_setBookTags (_tmp55_, _tmp57_);
#line 280 "../src/database.vala"
			_tmp58_ = aBook;
#line 280 "../src/database.vala"
			_tmp59_ = stmt;
#line 280 "../src/database.vala"
			_tmp60_ = (const gchar*) sqlite3_column_text (_tmp59_, 9);
#line 280 "../src/database.vala"
			bookworm_app_book_setAnnotationTags (_tmp58_, _tmp60_);
#line 281 "../src/database.vala"
			_tmp61_ = aBook;
#line 281 "../src/database.vala"
			_tmp62_ = stmt;
#line 281 "../src/database.vala"
			_tmp63_ = (const gchar*) sqlite3_column_text (_tmp62_, 10);
#line 281 "../src/database.vala"
			bookworm_app_book_setBookRating (_tmp61_, atoi (_tmp63_));
#line 282 "../src/database.vala"
			_tmp64_ = aBook;
#line 282 "../src/database.vala"
			_tmp65_ = stmt;
#line 282 "../src/database.vala"
			_tmp66_ = (const gchar*) sqlite3_column_text (_tmp65_, 11);
#line 282 "../src/database.vala"
			bookworm_app_book_setBookExtractionLocation (_tmp64_, _tmp66_);
#line 283 "../src/database.vala"
			_tmp67_ = aBook;
#line 283 "../src/database.vala"
			_tmp68_ = stmt;
#line 283 "../src/database.vala"
			_tmp69_ = (const gchar*) sqlite3_column_text (_tmp68_, 12);
#line 283 "../src/database.vala"
			bookworm_app_book_setBookTotalPages (_tmp67_, atoi (_tmp69_));
#line 284 "../src/database.vala"
			_tmp70_ = aBook;
#line 284 "../src/database.vala"
			_tmp71_ = stmt;
#line 284 "../src/database.vala"
			_tmp72_ = (const gchar*) sqlite3_column_text (_tmp71_, 13);
#line 284 "../src/database.vala"
			bookworm_app_book_setBookCreationDate (_tmp70_, _tmp72_);
#line 285 "../src/database.vala"
			_tmp73_ = aBook;
#line 285 "../src/database.vala"
			_tmp74_ = stmt;
#line 285 "../src/database.vala"
			_tmp75_ = (const gchar*) sqlite3_column_text (_tmp74_, 14);
#line 285 "../src/database.vala"
			bookworm_app_book_setBookLastModificationDate (_tmp73_, _tmp75_);
#line 286 "../src/database.vala"
			_tmp76_ = stmt;
#line 286 "../src/database.vala"
			_tmp77_ = g_strdup_printf ("%i", sqlite3_column_int (_tmp76_, 0));
#line 286 "../src/database.vala"
			_tmp78_ = _tmp77_;
#line 286 "../src/database.vala"
			_tmp79_ = g_strconcat ("Book details fetched from DB: id=", _tmp78_, NULL);
#line 286 "../src/database.vala"
			_tmp80_ = _tmp79_;
#line 286 "../src/database.vala"
			_tmp81_ = g_strconcat (_tmp80_, ",BOOK_LOCATION=", NULL);
#line 286 "../src/database.vala"
			_tmp82_ = _tmp81_;
#line 286 "../src/database.vala"
			_tmp83_ = stmt;
#line 286 "../src/database.vala"
			_tmp84_ = (const gchar*) sqlite3_column_text (_tmp83_, 1);
#line 286 "../src/database.vala"
			_tmp85_ = g_strconcat (_tmp82_, _tmp84_, NULL);
#line 286 "../src/database.vala"
			_tmp86_ = _tmp85_;
#line 286 "../src/database.vala"
			_tmp87_ = g_strconcat (_tmp86_, ",BOOK_TITLE=", NULL);
#line 286 "../src/database.vala"
			_tmp88_ = _tmp87_;
#line 286 "../src/database.vala"
			_tmp89_ = stmt;
#line 286 "../src/database.vala"
			_tmp90_ = (const gchar*) sqlite3_column_text (_tmp89_, 2);
#line 286 "../src/database.vala"
			_tmp91_ = g_strconcat (_tmp88_, _tmp90_, NULL);
#line 286 "../src/database.vala"
			_tmp92_ = _tmp91_;
#line 286 "../src/database.vala"
			_tmp93_ = g_strconcat (_tmp92_, ",BOOK_AUTHOR=", NULL);
#line 286 "../src/database.vala"
			_tmp94_ = _tmp93_;
#line 286 "../src/database.vala"
			_tmp95_ = stmt;
#line 286 "../src/database.vala"
			_tmp96_ = (const gchar*) sqlite3_column_text (_tmp95_, 3);
#line 286 "../src/database.vala"
			_tmp97_ = g_strconcat (_tmp94_, _tmp96_, NULL);
#line 286 "../src/database.vala"
			_tmp98_ = _tmp97_;
#line 286 "../src/database.vala"
			_tmp99_ = g_strconcat (_tmp98_, ",BOOK_COVER_IMAGE_LOCATION=", NULL);
#line 286 "../src/database.vala"
			_tmp100_ = _tmp99_;
#line 286 "../src/database.vala"
			_tmp101_ = stmt;
#line 286 "../src/database.vala"
			_tmp102_ = (const gchar*) sqlite3_column_text (_tmp101_, 4);
#line 286 "../src/database.vala"
			_tmp103_ = g_strconcat (_tmp100_, _tmp102_, NULL);
#line 286 "../src/database.vala"
			_tmp104_ = _tmp103_;
#line 286 "../src/database.vala"
			_tmp105_ = g_strconcat (_tmp104_, ",IS_BOOK_COVER_IMAGE_PRESENT=", NULL);
#line 286 "../src/database.vala"
			_tmp106_ = _tmp105_;
#line 286 "../src/database.vala"
			_tmp107_ = stmt;
#line 286 "../src/database.vala"
			_tmp108_ = (const gchar*) sqlite3_column_text (_tmp107_, 5);
#line 286 "../src/database.vala"
			_tmp109_ = g_strconcat (_tmp106_, _tmp108_, NULL);
#line 286 "../src/database.vala"
			_tmp110_ = _tmp109_;
#line 286 "../src/database.vala"
			_tmp111_ = g_strconcat (_tmp110_, ",BOOK_LAST_READ_PAGE_NUMBER=", NULL);
#line 286 "../src/database.vala"
			_tmp112_ = _tmp111_;
#line 286 "../src/database.vala"
			_tmp113_ = stmt;
#line 286 "../src/database.vala"
			_tmp114_ = (const gchar*) sqlite3_column_text (_tmp113_, 6);
#line 286 "../src/database.vala"
			_tmp115_ = g_strconcat (_tmp112_, _tmp114_, NULL);
#line 286 "../src/database.vala"
			_tmp116_ = _tmp115_;
#line 286 "../src/database.vala"
			_tmp117_ = g_strconcat (_tmp116_, ",BOOK_PUBLISH_DATE=", NULL);
#line 286 "../src/database.vala"
			_tmp118_ = _tmp117_;
#line 286 "../src/database.vala"
			_tmp119_ = stmt;
#line 286 "../src/database.vala"
			_tmp120_ = (const gchar*) sqlite3_column_text (_tmp119_, 7);
#line 286 "../src/database.vala"
			_tmp121_ = g_strconcat (_tmp118_, _tmp120_, NULL);
#line 286 "../src/database.vala"
			_tmp122_ = _tmp121_;
#line 286 "../src/database.vala"
			_tmp123_ = g_strconcat (_tmp122_, ",TAGS=", NULL);
#line 286 "../src/database.vala"
			_tmp124_ = _tmp123_;
#line 286 "../src/database.vala"
			_tmp125_ = stmt;
#line 286 "../src/database.vala"
			_tmp126_ = (const gchar*) sqlite3_column_text (_tmp125_, 8);
#line 286 "../src/database.vala"
			_tmp127_ = g_strconcat (_tmp124_, _tmp126_, NULL);
#line 286 "../src/database.vala"
			_tmp128_ = _tmp127_;
#line 286 "../src/database.vala"
			_tmp129_ = g_strconcat (_tmp128_, ",ANNOTATION_TAGS=", NULL);
#line 286 "../src/database.vala"
			_tmp130_ = _tmp129_;
#line 286 "../src/database.vala"
			_tmp131_ = stmt;
#line 286 "../src/database.vala"
			_tmp132_ = (const gchar*) sqlite3_column_text (_tmp131_, 9);
#line 286 "../src/database.vala"
			_tmp133_ = g_strconcat (_tmp130_, _tmp132_, NULL);
#line 286 "../src/database.vala"
			_tmp134_ = _tmp133_;
#line 286 "../src/database.vala"
			_tmp135_ = g_strconcat (_tmp134_, ",RATINGS=", NULL);
#line 286 "../src/database.vala"
			_tmp136_ = _tmp135_;
#line 286 "../src/database.vala"
			_tmp137_ = stmt;
#line 286 "../src/database.vala"
			_tmp138_ = (const gchar*) sqlite3_column_text (_tmp137_, 10);
#line 286 "../src/database.vala"
			_tmp139_ = g_strconcat (_tmp136_, _tmp138_, NULL);
#line 286 "../src/database.vala"
			_tmp140_ = _tmp139_;
#line 286 "../src/database.vala"
			_tmp141_ = g_strconcat (_tmp140_, ",CONTENT_EXTRACTION_LOCATION=", NULL);
#line 286 "../src/database.vala"
			_tmp142_ = _tmp141_;
#line 286 "../src/database.vala"
			_tmp143_ = stmt;
#line 286 "../src/database.vala"
			_tmp144_ = (const gchar*) sqlite3_column_text (_tmp143_, 11);
#line 286 "../src/database.vala"
			_tmp145_ = g_strconcat (_tmp142_, _tmp144_, NULL);
#line 286 "../src/database.vala"
			_tmp146_ = _tmp145_;
#line 286 "../src/database.vala"
			_tmp147_ = g_strconcat (_tmp146_, ",BOOK_TOTAL_PAGES=", NULL);
#line 286 "../src/database.vala"
			_tmp148_ = _tmp147_;
#line 286 "../src/database.vala"
			_tmp149_ = stmt;
#line 286 "../src/database.vala"
			_tmp150_ = (const gchar*) sqlite3_column_text (_tmp149_, 12);
#line 286 "../src/database.vala"
			_tmp151_ = g_strconcat (_tmp148_, _tmp150_, NULL);
#line 286 "../src/database.vala"
			_tmp152_ = _tmp151_;
#line 286 "../src/database.vala"
			_tmp153_ = g_strconcat (_tmp152_, ",creation_date=", NULL);
#line 286 "../src/database.vala"
			_tmp154_ = _tmp153_;
#line 286 "../src/database.vala"
			_tmp155_ = stmt;
#line 286 "../src/database.vala"
			_tmp156_ = (const gchar*) sqlite3_column_text (_tmp155_, 13);
#line 286 "../src/database.vala"
			_tmp157_ = g_strconcat (_tmp154_, _tmp156_, NULL);
#line 286 "../src/database.vala"
			_tmp158_ = _tmp157_;
#line 286 "../src/database.vala"
			_tmp159_ = g_strconcat (_tmp158_, ",modification_date=", NULL);
#line 286 "../src/database.vala"
			_tmp160_ = _tmp159_;
#line 286 "../src/database.vala"
			_tmp161_ = stmt;
#line 286 "../src/database.vala"
			_tmp162_ = (const gchar*) sqlite3_column_text (_tmp161_, 14);
#line 286 "../src/database.vala"
			_tmp163_ = g_strconcat (_tmp160_, _tmp162_, NULL);
#line 286 "../src/database.vala"
			_tmp164_ = _tmp163_;
#line 286 "../src/database.vala"
			g_debug ("database.vala:286: %s", _tmp164_);
#line 286 "../src/database.vala"
			_g_free0 (_tmp164_);
#line 286 "../src/database.vala"
			_g_free0 (_tmp160_);
#line 286 "../src/database.vala"
			_g_free0 (_tmp158_);
#line 286 "../src/database.vala"
			_g_free0 (_tmp154_);
#line 286 "../src/database.vala"
			_g_free0 (_tmp152_);
#line 286 "../src/database.vala"
			_g_free0 (_tmp148_);
#line 286 "../src/database.vala"
			_g_free0 (_tmp146_);
#line 286 "../src/database.vala"
			_g_free0 (_tmp142_);
#line 286 "../src/database.vala"
			_g_free0 (_tmp140_);
#line 286 "../src/database.vala"
			_g_free0 (_tmp136_);
#line 286 "../src/database.vala"
			_g_free0 (_tmp134_);
#line 286 "../src/database.vala"
			_g_free0 (_tmp130_);
#line 286 "../src/database.vala"
			_g_free0 (_tmp128_);
#line 286 "../src/database.vala"
			_g_free0 (_tmp124_);
#line 286 "../src/database.vala"
			_g_free0 (_tmp122_);
#line 286 "../src/database.vala"
			_g_free0 (_tmp118_);
#line 286 "../src/database.vala"
			_g_free0 (_tmp116_);
#line 286 "../src/database.vala"
			_g_free0 (_tmp112_);
#line 286 "../src/database.vala"
			_g_free0 (_tmp110_);
#line 286 "../src/database.vala"
			_g_free0 (_tmp106_);
#line 286 "../src/database.vala"
			_g_free0 (_tmp104_);
#line 286 "../src/database.vala"
			_g_free0 (_tmp100_);
#line 286 "../src/database.vala"
			_g_free0 (_tmp98_);
#line 286 "../src/database.vala"
			_g_free0 (_tmp94_);
#line 286 "../src/database.vala"
			_g_free0 (_tmp92_);
#line 286 "../src/database.vala"
			_g_free0 (_tmp88_);
#line 286 "../src/database.vala"
			_g_free0 (_tmp86_);
#line 286 "../src/database.vala"
			_g_free0 (_tmp82_);
#line 286 "../src/database.vala"
			_g_free0 (_tmp80_);
#line 286 "../src/database.vala"
			_g_free0 (_tmp78_);
#line 2678 "database.c"
		}
	}
#line 303 "../src/database.vala"
	_tmp165_ = stmt;
#line 303 "../src/database.vala"
	sqlite3_reset (_tmp165_);
#line 304 "../src/database.vala"
	_tmp166_ = aBook;
#line 304 "../src/database.vala"
	_tmp167_ = bookworm_app_book_getBookLocation (_tmp166_);
#line 304 "../src/database.vala"
	_tmp168_ = _tmp167_;
#line 304 "../src/database.vala"
	_tmp169_ = g_strconcat ("[END] [FUNCTION:getBookFromDB] Book fetched [", _tmp168_, NULL);
#line 304 "../src/database.vala"
	_tmp170_ = _tmp169_;
#line 304 "../src/database.vala"
	_tmp171_ = g_strconcat (_tmp170_, "]", NULL);
#line 304 "../src/database.vala"
	_tmp172_ = _tmp171_;
#line 304 "../src/database.vala"
	g_info ("database.vala:304: %s", _tmp172_);
#line 304 "../src/database.vala"
	_g_free0 (_tmp172_);
#line 304 "../src/database.vala"
	_g_free0 (_tmp170_);
#line 304 "../src/database.vala"
	_g_free0 (_tmp168_);
#line 305 "../src/database.vala"
	result = aBook;
#line 305 "../src/database.vala"
	_sqlite3_finalize0 (stmt);
#line 305 "../src/database.vala"
	return result;
#line 2713 "database.c"
}

static gpointer
_bookworm_app_book_ref0 (gpointer self)
{
#line 319 "../src/database.vala"
	return self ? bookworm_app_book_ref (self) : NULL;
#line 2721 "database.c"
}

BookwormAppBook*
bookworm_app_db_getBookMetaDataFromDB (BookwormAppBook* aBook)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp4_;
	sqlite3* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	sqlite3_stmt* _tmp10_ = NULL;
	gint _tmp11_;
	sqlite3_stmt* _tmp16_;
	sqlite3_stmt* _tmp68_;
	gchar* _tmp69_;
	gchar* _tmp70_;
	gchar* _tmp71_;
	gchar* _tmp72_;
	BookwormAppBook* _tmp73_;
	BookwormAppBook* result = NULL;
#line 308 "../src/database.vala"
	g_return_val_if_fail (aBook != NULL, NULL);
#line 309 "../src/database.vala"
	_tmp0_ = bookworm_app_book_getBookLocation (aBook);
#line 309 "../src/database.vala"
	_tmp1_ = _tmp0_;
#line 309 "../src/database.vala"
	_tmp2_ = g_strconcat ("[START] [FUNCTION:getBookMetaDataFromDB] book.location=", _tmp1_, NULL);
#line 309 "../src/database.vala"
	_tmp3_ = _tmp2_;
#line 309 "../src/database.vala"
	g_info ("database.vala:309: %s", _tmp3_);
#line 309 "../src/database.vala"
	_g_free0 (_tmp3_);
#line 309 "../src/database.vala"
	_g_free0 (_tmp1_);
#line 311 "../src/database.vala"
	_tmp4_ = g_strdup ("SELECT BOOK_TOC_DATA, BOOKMARKS, CONTENT_DATA_LIST, BOOK_LAST_SCROLL_P" \
"OSITION, " "BOOK_ANNOTATIONS FROM " BOOKWORM_APP_DB_BOOKMETADATA_TABLE_NAME " WHERE id = ?");
#line 311 "../src/database.vala"
	_g_free0 (bookworm_app_db_queryString);
#line 311 "../src/database.vala"
	bookworm_app_db_queryString = _tmp4_;
#line 313 "../src/database.vala"
	_tmp5_ = bookworm_app_db_bookwormDB;
#line 313 "../src/database.vala"
	_tmp6_ = bookworm_app_db_queryString;
#line 313 "../src/database.vala"
	_tmp7_ = bookworm_app_db_queryString;
#line 313 "../src/database.vala"
	_tmp8_ = strlen (_tmp7_);
#line 313 "../src/database.vala"
	_tmp9_ = _tmp8_;
#line 313 "../src/database.vala"
	_tmp11_ = sqlite3_prepare_v2 (_tmp5_, _tmp6_, _tmp9_, &_tmp10_, NULL);
#line 313 "../src/database.vala"
	_sqlite3_finalize0 (stmt);
#line 313 "../src/database.vala"
	stmt = _tmp10_;
#line 313 "../src/database.vala"
	bookworm_app_db_executionStatus = _tmp11_;
#line 314 "../src/database.vala"
	if (bookworm_app_db_executionStatus != SQLITE_OK) {
#line 2790 "database.c"
		const gchar* _tmp12_;
		sqlite3* _tmp13_;
		sqlite3* _tmp14_;
		const gchar* _tmp15_;
#line 315 "../src/database.vala"
		_tmp12_ = bookworm_app_db_queryString;
#line 315 "../src/database.vala"
		_tmp13_ = bookworm_app_db_bookwormDB;
#line 315 "../src/database.vala"
		_tmp14_ = bookworm_app_db_bookwormDB;
#line 315 "../src/database.vala"
		_tmp15_ = sqlite3_errmsg (_tmp14_);
#line 315 "../src/database.vala"
		bookworm_app_db_report_query_execution_error (_tmp12_, sqlite3_errcode (_tmp13_), _tmp15_);
#line 2805 "database.c"
	}
#line 317 "../src/database.vala"
	_tmp16_ = stmt;
#line 317 "../src/database.vala"
	sqlite3_bind_int (_tmp16_, 1, bookworm_app_book_getBookId (aBook));
#line 318 "../src/database.vala"
	while (TRUE) {
#line 2813 "database.c"
		sqlite3_stmt* _tmp17_;
		BookwormAppBook* _tmp18_;
		sqlite3_stmt* _tmp19_;
		const gchar* _tmp20_;
		BookwormAppBook* _tmp21_;
		sqlite3_stmt* _tmp22_;
		const gchar* _tmp23_;
		BookwormAppBook* _tmp24_;
		sqlite3_stmt* _tmp25_;
		const gchar* _tmp26_;
		BookwormAppBook* _tmp27_;
		sqlite3_stmt* _tmp28_;
		const gchar* _tmp29_;
		sqlite3_stmt* _tmp30_;
		const gchar* _tmp31_;
		GeeTreeMap* _tmp32_;
		GeeTreeMap* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		sqlite3_stmt* _tmp40_;
		const gchar* _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_;
		sqlite3_stmt* _tmp46_;
		const gchar* _tmp47_;
		gchar* _tmp48_;
		gchar* _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_;
		sqlite3_stmt* _tmp52_;
		const gchar* _tmp53_;
		gchar* _tmp54_;
		gchar* _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
		sqlite3_stmt* _tmp58_;
		const gchar* _tmp59_;
		gchar* _tmp60_;
		gchar* _tmp61_;
		gchar* _tmp62_;
		gchar* _tmp63_;
		sqlite3_stmt* _tmp64_;
		const gchar* _tmp65_;
		gchar* _tmp66_;
		gchar* _tmp67_;
#line 318 "../src/database.vala"
		_tmp17_ = stmt;
#line 318 "../src/database.vala"
		if (!(sqlite3_step (_tmp17_) == SQLITE_ROW)) {
#line 318 "../src/database.vala"
			break;
#line 2871 "database.c"
		}
#line 319 "../src/database.vala"
		_tmp18_ = _bookworm_app_book_ref0 (aBook);
#line 319 "../src/database.vala"
		_tmp19_ = stmt;
#line 319 "../src/database.vala"
		_tmp20_ = (const gchar*) sqlite3_column_text (_tmp19_, 0);
#line 319 "../src/database.vala"
		_tmp21_ = bookworm_app_utils_convertStringToTOC (_tmp18_, _tmp20_);
#line 319 "../src/database.vala"
		_bookworm_app_book_unref0 (aBook);
#line 319 "../src/database.vala"
		aBook = _tmp21_;
#line 320 "../src/database.vala"
		_tmp22_ = stmt;
#line 320 "../src/database.vala"
		_tmp23_ = (const gchar*) sqlite3_column_text (_tmp22_, 1);
#line 320 "../src/database.vala"
		bookworm_app_book_setBookmark (aBook, -10, _tmp23_);
#line 321 "../src/database.vala"
		_tmp24_ = _bookworm_app_book_ref0 (aBook);
#line 321 "../src/database.vala"
		_tmp25_ = stmt;
#line 321 "../src/database.vala"
		_tmp26_ = (const gchar*) sqlite3_column_text (_tmp25_, 2);
#line 321 "../src/database.vala"
		_tmp27_ = bookworm_app_utils_convertStringToContentList (_tmp24_, _tmp26_);
#line 321 "../src/database.vala"
		_bookworm_app_book_unref0 (aBook);
#line 321 "../src/database.vala"
		aBook = _tmp27_;
#line 322 "../src/database.vala"
		_tmp28_ = stmt;
#line 322 "../src/database.vala"
		_tmp29_ = (const gchar*) sqlite3_column_text (_tmp28_, 3);
#line 322 "../src/database.vala"
		bookworm_app_book_setBookScrollPos (aBook, atoi (_tmp29_));
#line 323 "../src/database.vala"
		_tmp30_ = stmt;
#line 323 "../src/database.vala"
		_tmp31_ = (const gchar*) sqlite3_column_text (_tmp30_, 4);
#line 323 "../src/database.vala"
		_tmp32_ = bookworm_app_utils_convertStringToTreeMap (_tmp31_);
#line 323 "../src/database.vala"
		_tmp33_ = _tmp32_;
#line 323 "../src/database.vala"
		bookworm_app_book_setAnnotationList (aBook, _tmp33_);
#line 323 "../src/database.vala"
		_g_object_unref0 (_tmp33_);
#line 324 "../src/database.vala"
		_tmp34_ = g_strdup_printf ("%i", bookworm_app_book_getBookId (aBook));
#line 324 "../src/database.vala"
		_tmp35_ = _tmp34_;
#line 324 "../src/database.vala"
		_tmp36_ = g_strconcat ("Book MetaData details fetched from DB: id=", _tmp35_, NULL);
#line 324 "../src/database.vala"
		_tmp37_ = _tmp36_;
#line 324 "../src/database.vala"
		_tmp38_ = g_strconcat (_tmp37_, ", BOOK_TOC_DATA=", NULL);
#line 324 "../src/database.vala"
		_tmp39_ = _tmp38_;
#line 324 "../src/database.vala"
		_tmp40_ = stmt;
#line 324 "../src/database.vala"
		_tmp41_ = (const gchar*) sqlite3_column_text (_tmp40_, 0);
#line 324 "../src/database.vala"
		_tmp42_ = g_strconcat (_tmp39_, _tmp41_, NULL);
#line 324 "../src/database.vala"
		_tmp43_ = _tmp42_;
#line 324 "../src/database.vala"
		_tmp44_ = g_strconcat (_tmp43_, ", BOOKMARKS=", NULL);
#line 324 "../src/database.vala"
		_tmp45_ = _tmp44_;
#line 324 "../src/database.vala"
		_tmp46_ = stmt;
#line 324 "../src/database.vala"
		_tmp47_ = (const gchar*) sqlite3_column_text (_tmp46_, 1);
#line 324 "../src/database.vala"
		_tmp48_ = g_strconcat (_tmp45_, _tmp47_, NULL);
#line 324 "../src/database.vala"
		_tmp49_ = _tmp48_;
#line 324 "../src/database.vala"
		_tmp50_ = g_strconcat (_tmp49_, ", CONTENT_DATA_LIST=", NULL);
#line 324 "../src/database.vala"
		_tmp51_ = _tmp50_;
#line 324 "../src/database.vala"
		_tmp52_ = stmt;
#line 324 "../src/database.vala"
		_tmp53_ = (const gchar*) sqlite3_column_text (_tmp52_, 2);
#line 324 "../src/database.vala"
		_tmp54_ = g_strconcat (_tmp51_, _tmp53_, NULL);
#line 324 "../src/database.vala"
		_tmp55_ = _tmp54_;
#line 324 "../src/database.vala"
		_tmp56_ = g_strconcat (_tmp55_, ", BOOK_LAST_SCROLL_POSITION=", NULL);
#line 324 "../src/database.vala"
		_tmp57_ = _tmp56_;
#line 324 "../src/database.vala"
		_tmp58_ = stmt;
#line 324 "../src/database.vala"
		_tmp59_ = (const gchar*) sqlite3_column_text (_tmp58_, 3);
#line 324 "../src/database.vala"
		_tmp60_ = g_strconcat (_tmp57_, _tmp59_, NULL);
#line 324 "../src/database.vala"
		_tmp61_ = _tmp60_;
#line 324 "../src/database.vala"
		_tmp62_ = g_strconcat (_tmp61_, ", BOOK_ANNOTATIONS=", NULL);
#line 324 "../src/database.vala"
		_tmp63_ = _tmp62_;
#line 324 "../src/database.vala"
		_tmp64_ = stmt;
#line 324 "../src/database.vala"
		_tmp65_ = (const gchar*) sqlite3_column_text (_tmp64_, 4);
#line 324 "../src/database.vala"
		_tmp66_ = g_strconcat (_tmp63_, _tmp65_, NULL);
#line 324 "../src/database.vala"
		_tmp67_ = _tmp66_;
#line 324 "../src/database.vala"
		g_debug ("database.vala:324: %s", _tmp67_);
#line 324 "../src/database.vala"
		_g_free0 (_tmp67_);
#line 324 "../src/database.vala"
		_g_free0 (_tmp63_);
#line 324 "../src/database.vala"
		_g_free0 (_tmp61_);
#line 324 "../src/database.vala"
		_g_free0 (_tmp57_);
#line 324 "../src/database.vala"
		_g_free0 (_tmp55_);
#line 324 "../src/database.vala"
		_g_free0 (_tmp51_);
#line 324 "../src/database.vala"
		_g_free0 (_tmp49_);
#line 324 "../src/database.vala"
		_g_free0 (_tmp45_);
#line 324 "../src/database.vala"
		_g_free0 (_tmp43_);
#line 324 "../src/database.vala"
		_g_free0 (_tmp39_);
#line 324 "../src/database.vala"
		_g_free0 (_tmp37_);
#line 324 "../src/database.vala"
		_g_free0 (_tmp35_);
#line 3015 "database.c"
	}
#line 331 "../src/database.vala"
	_tmp68_ = stmt;
#line 331 "../src/database.vala"
	sqlite3_reset (_tmp68_);
#line 332 "../src/database.vala"
	_tmp69_ = bookworm_app_book_getBookLocation (aBook);
#line 332 "../src/database.vala"
	_tmp70_ = _tmp69_;
#line 332 "../src/database.vala"
	_tmp71_ = g_strconcat ("[END] [FUNCTION:getBookMetaDataFromDB] book.location=", _tmp70_, NULL);
#line 332 "../src/database.vala"
	_tmp72_ = _tmp71_;
#line 332 "../src/database.vala"
	g_info ("database.vala:332: %s", _tmp72_);
#line 332 "../src/database.vala"
	_g_free0 (_tmp72_);
#line 332 "../src/database.vala"
	_g_free0 (_tmp70_);
#line 333 "../src/database.vala"
	_tmp73_ = _bookworm_app_book_ref0 (aBook);
#line 333 "../src/database.vala"
	result = _tmp73_;
#line 333 "../src/database.vala"
	_sqlite3_finalize0 (stmt);
#line 333 "../src/database.vala"
	_bookworm_app_book_unref0 (aBook);
#line 333 "../src/database.vala"
	return result;
#line 3045 "database.c"
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result = NULL;
#line 37 "glib-2.0.vapi"
	if (self) {
#line 3054 "database.c"
		gchar* _tmp0_;
#line 38 "glib-2.0.vapi"
		_tmp0_ = g_strdup ("true");
#line 38 "glib-2.0.vapi"
		result = _tmp0_;
#line 38 "glib-2.0.vapi"
		return result;
#line 3062 "database.c"
	} else {
		gchar* _tmp1_;
#line 40 "glib-2.0.vapi"
		_tmp1_ = g_strdup ("false");
#line 40 "glib-2.0.vapi"
		result = _tmp1_;
#line 40 "glib-2.0.vapi"
		return result;
#line 3071 "database.c"
	}
}

gint
bookworm_app_db_addBookToDataBase (BookwormAppBook* aBook)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	sqlite3_stmt* stmt = NULL;
	gint insertedBookID = 0;
	gchar* _tmp4_;
	sqlite3* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	sqlite3_stmt* _tmp10_ = NULL;
	gint _tmp11_;
	sqlite3_stmt* _tmp16_;
	gchar* _tmp17_;
	GDestroyNotify _tmp18_;
	sqlite3_stmt* _tmp19_;
	gchar* _tmp20_;
	GDestroyNotify _tmp21_;
	sqlite3_stmt* _tmp22_;
	gchar* _tmp23_;
	GDestroyNotify _tmp24_;
	sqlite3_stmt* _tmp25_;
	gchar* _tmp26_;
	GDestroyNotify _tmp27_;
	sqlite3_stmt* _tmp28_;
	gchar* _tmp29_;
	GDestroyNotify _tmp30_;
	sqlite3_stmt* _tmp31_;
	gchar* _tmp32_;
	GDestroyNotify _tmp33_;
	sqlite3_stmt* _tmp34_;
	sqlite3_stmt* _tmp35_;
	gchar* _tmp36_;
	sqlite3* _tmp37_;
	const gchar* _tmp38_;
	const gchar* _tmp39_;
	gint _tmp40_;
	gint _tmp41_;
	sqlite3_stmt* _tmp42_ = NULL;
	gint _tmp43_;
	sqlite3_stmt* _tmp48_;
	gchar* _tmp49_;
	GDestroyNotify _tmp50_;
	sqlite3_stmt* _tmp53_;
	gchar* _tmp54_;
	gchar* _tmp55_;
	gchar* _tmp56_;
	gchar* _tmp57_;
	gint result = 0;
#line 336 "../src/database.vala"
	g_return_val_if_fail (aBook != NULL, 0);
#line 337 "../src/database.vala"
	_tmp0_ = bookworm_app_book_getBookLocation (aBook);
#line 337 "../src/database.vala"
	_tmp1_ = _tmp0_;
#line 337 "../src/database.vala"
	_tmp2_ = g_strconcat ("[START] [FUNCTION:addBookToDataBase] book.location=", _tmp1_, NULL);
#line 337 "../src/database.vala"
	_tmp3_ = _tmp2_;
#line 337 "../src/database.vala"
	g_info ("database.vala:337: %s", _tmp3_);
#line 337 "../src/database.vala"
	_g_free0 (_tmp3_);
#line 337 "../src/database.vala"
	_g_free0 (_tmp1_);
#line 339 "../src/database.vala"
	insertedBookID = 0;
#line 340 "../src/database.vala"
	_tmp4_ = g_strdup ("INSERT INTO " BOOKWORM_APP_DB_BOOKWORM_TABLE_NAME " (BOOK_LOCATION, BOOK_TITLE, BOOK_AUTHOR, " "BOOK_COVER_IMAGE_LOCATION, IS_BOOK_COVER_IMAGE_PRESENT, CONTENT_EXTRAC" \
"TION_LOCATION, " "creation_date, modification_date) " "VALUES (?, ?, ?, ?, ?, ?, CAST (strftime ('%s', 'now') " "AS INT), CAST (strftime ('%s', 'now') AS INT))");
#line 340 "../src/database.vala"
	_g_free0 (bookworm_app_db_queryString);
#line 340 "../src/database.vala"
	bookworm_app_db_queryString = _tmp4_;
#line 344 "../src/database.vala"
	_tmp5_ = bookworm_app_db_bookwormDB;
#line 344 "../src/database.vala"
	_tmp6_ = bookworm_app_db_queryString;
#line 344 "../src/database.vala"
	_tmp7_ = bookworm_app_db_queryString;
#line 344 "../src/database.vala"
	_tmp8_ = strlen (_tmp7_);
#line 344 "../src/database.vala"
	_tmp9_ = _tmp8_;
#line 344 "../src/database.vala"
	_tmp11_ = sqlite3_prepare_v2 (_tmp5_, _tmp6_, _tmp9_, &_tmp10_, NULL);
#line 344 "../src/database.vala"
	_sqlite3_finalize0 (stmt);
#line 344 "../src/database.vala"
	stmt = _tmp10_;
#line 344 "../src/database.vala"
	bookworm_app_db_executionStatus = _tmp11_;
#line 345 "../src/database.vala"
	if (bookworm_app_db_executionStatus != SQLITE_OK) {
#line 3173 "database.c"
		const gchar* _tmp12_;
		sqlite3* _tmp13_;
		sqlite3* _tmp14_;
		const gchar* _tmp15_;
#line 346 "../src/database.vala"
		_tmp12_ = bookworm_app_db_queryString;
#line 346 "../src/database.vala"
		_tmp13_ = bookworm_app_db_bookwormDB;
#line 346 "../src/database.vala"
		_tmp14_ = bookworm_app_db_bookwormDB;
#line 346 "../src/database.vala"
		_tmp15_ = sqlite3_errmsg (_tmp14_);
#line 346 "../src/database.vala"
		bookworm_app_db_report_query_execution_error (_tmp12_, sqlite3_errcode (_tmp13_), _tmp15_);
#line 347 "../src/database.vala"
		result = -1;
#line 347 "../src/database.vala"
		_sqlite3_finalize0 (stmt);
#line 347 "../src/database.vala"
		return result;
#line 3194 "database.c"
	}
#line 349 "../src/database.vala"
	_tmp16_ = stmt;
#line 349 "../src/database.vala"
	_tmp17_ = bookworm_app_book_getBookLocation (aBook);
#line 349 "../src/database.vala"
	_tmp18_ = g_free;
#line 349 "../src/database.vala"
	sqlite3_bind_text (_tmp16_, 1, _tmp17_, -1, _tmp18_);
#line 350 "../src/database.vala"
	_tmp19_ = stmt;
#line 350 "../src/database.vala"
	_tmp20_ = bookworm_app_book_getBookTitle (aBook);
#line 350 "../src/database.vala"
	_tmp21_ = g_free;
#line 350 "../src/database.vala"
	sqlite3_bind_text (_tmp19_, 2, _tmp20_, -1, _tmp21_);
#line 351 "../src/database.vala"
	_tmp22_ = stmt;
#line 351 "../src/database.vala"
	_tmp23_ = bookworm_app_book_getBookAuthor (aBook);
#line 351 "../src/database.vala"
	_tmp24_ = g_free;
#line 351 "../src/database.vala"
	sqlite3_bind_text (_tmp22_, 3, _tmp23_, -1, _tmp24_);
#line 352 "../src/database.vala"
	_tmp25_ = stmt;
#line 352 "../src/database.vala"
	_tmp26_ = bookworm_app_book_getBookCoverLocation (aBook);
#line 352 "../src/database.vala"
	_tmp27_ = g_free;
#line 352 "../src/database.vala"
	sqlite3_bind_text (_tmp25_, 4, _tmp26_, -1, _tmp27_);
#line 353 "../src/database.vala"
	_tmp28_ = stmt;
#line 353 "../src/database.vala"
	_tmp29_ = bool_to_string (bookworm_app_book_getIsBookCoverImagePresent (aBook));
#line 353 "../src/database.vala"
	_tmp30_ = g_free;
#line 353 "../src/database.vala"
	sqlite3_bind_text (_tmp28_, 5, _tmp29_, -1, _tmp30_);
#line 354 "../src/database.vala"
	_tmp31_ = stmt;
#line 354 "../src/database.vala"
	_tmp32_ = bookworm_app_book_getBookExtractionLocation (aBook);
#line 354 "../src/database.vala"
	_tmp33_ = g_free;
#line 354 "../src/database.vala"
	sqlite3_bind_text (_tmp31_, 6, _tmp32_, -1, _tmp33_);
#line 356 "../src/database.vala"
	_tmp34_ = stmt;
#line 356 "../src/database.vala"
	sqlite3_step (_tmp34_);
#line 357 "../src/database.vala"
	_tmp35_ = stmt;
#line 357 "../src/database.vala"
	sqlite3_reset (_tmp35_);
#line 359 "../src/database.vala"
	_tmp36_ = g_strdup ("SELECT id FROM " BOOKWORM_APP_DB_BOOKWORM_TABLE_NAME " WHERE BOOK_LOCATION = ?");
#line 359 "../src/database.vala"
	_g_free0 (bookworm_app_db_queryString);
#line 359 "../src/database.vala"
	bookworm_app_db_queryString = _tmp36_;
#line 360 "../src/database.vala"
	_tmp37_ = bookworm_app_db_bookwormDB;
#line 360 "../src/database.vala"
	_tmp38_ = bookworm_app_db_queryString;
#line 360 "../src/database.vala"
	_tmp39_ = bookworm_app_db_queryString;
#line 360 "../src/database.vala"
	_tmp40_ = strlen (_tmp39_);
#line 360 "../src/database.vala"
	_tmp41_ = _tmp40_;
#line 360 "../src/database.vala"
	_tmp43_ = sqlite3_prepare_v2 (_tmp37_, _tmp38_, _tmp41_, &_tmp42_, NULL);
#line 360 "../src/database.vala"
	_sqlite3_finalize0 (stmt);
#line 360 "../src/database.vala"
	stmt = _tmp42_;
#line 360 "../src/database.vala"
	bookworm_app_db_executionStatus = _tmp43_;
#line 361 "../src/database.vala"
	if (bookworm_app_db_executionStatus != SQLITE_OK) {
#line 3278 "database.c"
		const gchar* _tmp44_;
		sqlite3* _tmp45_;
		sqlite3* _tmp46_;
		const gchar* _tmp47_;
#line 362 "../src/database.vala"
		_tmp44_ = bookworm_app_db_queryString;
#line 362 "../src/database.vala"
		_tmp45_ = bookworm_app_db_bookwormDB;
#line 362 "../src/database.vala"
		_tmp46_ = bookworm_app_db_bookwormDB;
#line 362 "../src/database.vala"
		_tmp47_ = sqlite3_errmsg (_tmp46_);
#line 362 "../src/database.vala"
		bookworm_app_db_report_query_execution_error (_tmp44_, sqlite3_errcode (_tmp45_), _tmp47_);
#line 3293 "database.c"
	}
#line 364 "../src/database.vala"
	_tmp48_ = stmt;
#line 364 "../src/database.vala"
	_tmp49_ = bookworm_app_book_getBookLocation (aBook);
#line 364 "../src/database.vala"
	_tmp50_ = g_free;
#line 364 "../src/database.vala"
	sqlite3_bind_text (_tmp48_, 1, _tmp49_, -1, _tmp50_);
#line 365 "../src/database.vala"
	while (TRUE) {
#line 3305 "database.c"
		sqlite3_stmt* _tmp51_;
		sqlite3_stmt* _tmp52_;
#line 365 "../src/database.vala"
		_tmp51_ = stmt;
#line 365 "../src/database.vala"
		if (!(sqlite3_step (_tmp51_) == SQLITE_ROW)) {
#line 365 "../src/database.vala"
			break;
#line 3314 "database.c"
		}
#line 366 "../src/database.vala"
		_tmp52_ = stmt;
#line 366 "../src/database.vala"
		insertedBookID = sqlite3_column_int (_tmp52_, 0);
#line 3320 "database.c"
	}
#line 368 "../src/database.vala"
	_tmp53_ = stmt;
#line 368 "../src/database.vala"
	sqlite3_reset (_tmp53_);
#line 369 "../src/database.vala"
	_tmp54_ = bookworm_app_book_getBookLocation (aBook);
#line 369 "../src/database.vala"
	_tmp55_ = _tmp54_;
#line 369 "../src/database.vala"
	_tmp56_ = g_strconcat ("[END] [FUNCTION:addBookToDataBase] book.location=", _tmp55_, NULL);
#line 369 "../src/database.vala"
	_tmp57_ = _tmp56_;
#line 369 "../src/database.vala"
	g_info ("database.vala:369: %s", _tmp57_);
#line 369 "../src/database.vala"
	_g_free0 (_tmp57_);
#line 369 "../src/database.vala"
	_g_free0 (_tmp55_);
#line 370 "../src/database.vala"
	result = insertedBookID;
#line 370 "../src/database.vala"
	_sqlite3_finalize0 (stmt);
#line 370 "../src/database.vala"
	return result;
#line 3346 "database.c"
}

gboolean
bookworm_app_db_removeBookFromDB (BookwormAppBook* aBook)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp4_;
	sqlite3* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	sqlite3_stmt* _tmp10_ = NULL;
	gint _tmp11_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	gchar* _tmp49_;
	gboolean result = FALSE;
#line 373 "../src/database.vala"
	g_return_val_if_fail (aBook != NULL, FALSE);
#line 374 "../src/database.vala"
	_tmp0_ = bookworm_app_book_getBookLocation (aBook);
#line 374 "../src/database.vala"
	_tmp1_ = _tmp0_;
#line 374 "../src/database.vala"
	_tmp2_ = g_strconcat ("[START] [FUNCTION:removeBookFromDB] book.location=", _tmp1_, NULL);
#line 374 "../src/database.vala"
	_tmp3_ = _tmp2_;
#line 374 "../src/database.vala"
	g_info ("database.vala:374: %s", _tmp3_);
#line 374 "../src/database.vala"
	_g_free0 (_tmp3_);
#line 374 "../src/database.vala"
	_g_free0 (_tmp1_);
#line 377 "../src/database.vala"
	_tmp4_ = g_strdup ("DELETE FROM " BOOKWORM_APP_DB_BOOKWORM_TABLE_NAME " WHERE id = ?");
#line 377 "../src/database.vala"
	_g_free0 (bookworm_app_db_queryString);
#line 377 "../src/database.vala"
	bookworm_app_db_queryString = _tmp4_;
#line 378 "../src/database.vala"
	_tmp5_ = bookworm_app_db_bookwormDB;
#line 378 "../src/database.vala"
	_tmp6_ = bookworm_app_db_queryString;
#line 378 "../src/database.vala"
	_tmp7_ = bookworm_app_db_queryString;
#line 378 "../src/database.vala"
	_tmp8_ = strlen (_tmp7_);
#line 378 "../src/database.vala"
	_tmp9_ = _tmp8_;
#line 378 "../src/database.vala"
	_tmp11_ = sqlite3_prepare_v2 (_tmp5_, _tmp6_, _tmp9_, &_tmp10_, NULL);
#line 378 "../src/database.vala"
	_sqlite3_finalize0 (stmt);
#line 378 "../src/database.vala"
	stmt = _tmp10_;
#line 378 "../src/database.vala"
	bookworm_app_db_executionStatus = _tmp11_;
#line 379 "../src/database.vala"
	if (bookworm_app_db_executionStatus != SQLITE_OK) {
#line 3412 "database.c"
		const gchar* _tmp12_;
		sqlite3* _tmp13_;
		sqlite3* _tmp14_;
		const gchar* _tmp15_;
#line 380 "../src/database.vala"
		_tmp12_ = bookworm_app_db_queryString;
#line 380 "../src/database.vala"
		_tmp13_ = bookworm_app_db_bookwormDB;
#line 380 "../src/database.vala"
		_tmp14_ = bookworm_app_db_bookwormDB;
#line 380 "../src/database.vala"
		_tmp15_ = sqlite3_errmsg (_tmp14_);
#line 380 "../src/database.vala"
		bookworm_app_db_report_query_execution_error (_tmp12_, sqlite3_errcode (_tmp13_), _tmp15_);
#line 381 "../src/database.vala"
		result = FALSE;
#line 381 "../src/database.vala"
		_sqlite3_finalize0 (stmt);
#line 381 "../src/database.vala"
		return result;
#line 3433 "database.c"
	} else {
		sqlite3_stmt* _tmp16_;
		sqlite3_stmt* _tmp17_;
		sqlite3_stmt* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		sqlite3* _tmp32_;
		const gchar* _tmp33_;
		const gchar* _tmp34_;
		gint _tmp35_;
		gint _tmp36_;
		sqlite3_stmt* _tmp37_ = NULL;
		gint _tmp38_;
#line 383 "../src/database.vala"
		_tmp16_ = stmt;
#line 383 "../src/database.vala"
		sqlite3_bind_int (_tmp16_, 1, bookworm_app_book_getBookId (aBook));
#line 384 "../src/database.vala"
		_tmp17_ = stmt;
#line 384 "../src/database.vala"
		sqlite3_step (_tmp17_);
#line 385 "../src/database.vala"
		_tmp18_ = stmt;
#line 385 "../src/database.vala"
		sqlite3_reset (_tmp18_);
#line 386 "../src/database.vala"
		_tmp19_ = bookworm_app_book_getBookTitle (aBook);
#line 386 "../src/database.vala"
		_tmp20_ = _tmp19_;
#line 386 "../src/database.vala"
		_tmp21_ = g_strconcat ("Removed this book from library table:", _tmp20_, NULL);
#line 386 "../src/database.vala"
		_tmp22_ = _tmp21_;
#line 386 "../src/database.vala"
		_tmp23_ = g_strconcat (_tmp22_, "[", NULL);
#line 386 "../src/database.vala"
		_tmp24_ = _tmp23_;
#line 386 "../src/database.vala"
		_tmp25_ = g_strdup_printf ("%i", bookworm_app_book_getBookId (aBook));
#line 386 "../src/database.vala"
		_tmp26_ = _tmp25_;
#line 386 "../src/database.vala"
		_tmp27_ = g_strconcat (_tmp24_, _tmp26_, NULL);
#line 386 "../src/database.vala"
		_tmp28_ = _tmp27_;
#line 386 "../src/database.vala"
		_tmp29_ = g_strconcat (_tmp28_, "]", NULL);
#line 386 "../src/database.vala"
		_tmp30_ = _tmp29_;
#line 386 "../src/database.vala"
		g_debug ("database.vala:386: %s", _tmp30_);
#line 386 "../src/database.vala"
		_g_free0 (_tmp30_);
#line 386 "../src/database.vala"
		_g_free0 (_tmp28_);
#line 386 "../src/database.vala"
		_g_free0 (_tmp26_);
#line 386 "../src/database.vala"
		_g_free0 (_tmp24_);
#line 386 "../src/database.vala"
		_g_free0 (_tmp22_);
#line 386 "../src/database.vala"
		_g_free0 (_tmp20_);
#line 388 "../src/database.vala"
		_tmp31_ = g_strdup ("DELETE FROM " BOOKWORM_APP_DB_BOOKMETADATA_TABLE_NAME " WHERE id = ?");
#line 388 "../src/database.vala"
		_g_free0 (bookworm_app_db_queryString);
#line 388 "../src/database.vala"
		bookworm_app_db_queryString = _tmp31_;
#line 389 "../src/database.vala"
		_tmp32_ = bookworm_app_db_bookwormDB;
#line 389 "../src/database.vala"
		_tmp33_ = bookworm_app_db_queryString;
#line 389 "../src/database.vala"
		_tmp34_ = bookworm_app_db_queryString;
#line 389 "../src/database.vala"
		_tmp35_ = strlen (_tmp34_);
#line 389 "../src/database.vala"
		_tmp36_ = _tmp35_;
#line 389 "../src/database.vala"
		_tmp38_ = sqlite3_prepare_v2 (_tmp32_, _tmp33_, _tmp36_, &_tmp37_, NULL);
#line 389 "../src/database.vala"
		_sqlite3_finalize0 (stmt);
#line 389 "../src/database.vala"
		stmt = _tmp37_;
#line 389 "../src/database.vala"
		bookworm_app_db_executionStatus = _tmp38_;
#line 390 "../src/database.vala"
		if (bookworm_app_db_executionStatus != SQLITE_OK) {
#line 3534 "database.c"
			const gchar* _tmp39_;
			sqlite3* _tmp40_;
			sqlite3* _tmp41_;
			const gchar* _tmp42_;
#line 391 "../src/database.vala"
			_tmp39_ = bookworm_app_db_queryString;
#line 391 "../src/database.vala"
			_tmp40_ = bookworm_app_db_bookwormDB;
#line 391 "../src/database.vala"
			_tmp41_ = bookworm_app_db_bookwormDB;
#line 391 "../src/database.vala"
			_tmp42_ = sqlite3_errmsg (_tmp41_);
#line 391 "../src/database.vala"
			bookworm_app_db_report_query_execution_error (_tmp39_, sqlite3_errcode (_tmp40_), _tmp42_);
#line 392 "../src/database.vala"
			result = FALSE;
#line 392 "../src/database.vala"
			_sqlite3_finalize0 (stmt);
#line 392 "../src/database.vala"
			return result;
#line 3555 "database.c"
		} else {
			sqlite3_stmt* _tmp43_;
			sqlite3_stmt* _tmp44_;
			sqlite3_stmt* _tmp45_;
#line 394 "../src/database.vala"
			_tmp43_ = stmt;
#line 394 "../src/database.vala"
			sqlite3_bind_int (_tmp43_, 1, bookworm_app_book_getBookId (aBook));
#line 395 "../src/database.vala"
			_tmp44_ = stmt;
#line 395 "../src/database.vala"
			sqlite3_step (_tmp44_);
#line 396 "../src/database.vala"
			_tmp45_ = stmt;
#line 396 "../src/database.vala"
			sqlite3_reset (_tmp45_);
#line 3572 "database.c"
		}
	}
#line 399 "../src/database.vala"
	_tmp46_ = bookworm_app_book_getBookLocation (aBook);
#line 399 "../src/database.vala"
	_tmp47_ = _tmp46_;
#line 399 "../src/database.vala"
	_tmp48_ = g_strconcat ("[END] [FUNCTION:removeBookFromDB] book.location=", _tmp47_, NULL);
#line 399 "../src/database.vala"
	_tmp49_ = _tmp48_;
#line 399 "../src/database.vala"
	g_info ("database.vala:399: %s", _tmp49_);
#line 399 "../src/database.vala"
	_g_free0 (_tmp49_);
#line 399 "../src/database.vala"
	_g_free0 (_tmp47_);
#line 400 "../src/database.vala"
	result = TRUE;
#line 400 "../src/database.vala"
	_sqlite3_finalize0 (stmt);
#line 400 "../src/database.vala"
	return result;
#line 3595 "database.c"
}

gboolean
bookworm_app_db_updateBookToDataBase (BookwormAppBook* aBook)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp4_;
	sqlite3* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	sqlite3_stmt* _tmp10_ = NULL;
	gint _tmp11_;
	sqlite3_stmt* _tmp16_;
	gchar* _tmp17_;
	GDestroyNotify _tmp18_;
	sqlite3_stmt* _tmp19_;
	gchar* _tmp20_;
	GDestroyNotify _tmp21_;
	sqlite3_stmt* _tmp22_;
	gchar* _tmp23_;
	GDestroyNotify _tmp24_;
	sqlite3_stmt* _tmp25_;
	gchar* _tmp26_;
	GDestroyNotify _tmp27_;
	sqlite3_stmt* _tmp28_;
	gchar* _tmp29_;
	GDestroyNotify _tmp30_;
	sqlite3_stmt* _tmp31_;
	gchar* _tmp32_;
	GDestroyNotify _tmp33_;
	sqlite3_stmt* _tmp34_;
	gchar* _tmp35_;
	GDestroyNotify _tmp36_;
	sqlite3_stmt* _tmp37_;
	gchar* _tmp38_;
	GDestroyNotify _tmp39_;
	sqlite3_stmt* _tmp40_;
	gchar* _tmp41_;
	GDestroyNotify _tmp42_;
	sqlite3_stmt* _tmp43_;
	gchar* _tmp44_;
	GDestroyNotify _tmp45_;
	sqlite3_stmt* _tmp46_;
	gchar* _tmp47_;
	GDestroyNotify _tmp48_;
	sqlite3_stmt* _tmp49_;
	sqlite3_stmt* _tmp50_;
	sqlite3_stmt* _tmp51_;
	gchar* _tmp52_;
	gchar* _tmp53_;
	gchar* _tmp54_;
	gchar* _tmp55_;
	gchar* _tmp56_;
	gchar* _tmp57_;
	gchar* _tmp58_;
	gchar* _tmp59_;
	gchar* _tmp60_;
	gchar* _tmp61_;
	gchar* _tmp62_;
	gchar* _tmp63_;
	gchar* _tmp64_;
	sqlite3* _tmp65_;
	const gchar* _tmp66_;
	const gchar* _tmp67_;
	gint _tmp68_;
	gint _tmp69_;
	sqlite3_stmt* _tmp70_ = NULL;
	gint _tmp71_;
	sqlite3_stmt* _tmp76_;
	gchar* _tmp77_;
	GDestroyNotify _tmp78_;
	sqlite3_stmt* _tmp79_;
	gchar* _tmp80_;
	GDestroyNotify _tmp81_;
	sqlite3_stmt* _tmp82_;
	gchar* _tmp83_;
	GDestroyNotify _tmp84_;
	sqlite3_stmt* _tmp85_;
	gchar* _tmp86_;
	GDestroyNotify _tmp87_;
	sqlite3_stmt* _tmp88_;
	GeeTreeMap* _tmp89_;
	GeeTreeMap* _tmp90_;
	gchar* _tmp91_;
	GDestroyNotify _tmp92_;
	sqlite3_stmt* _tmp93_;
	sqlite3_stmt* _tmp94_;
	sqlite3_stmt* _tmp95_;
	sqlite3* _tmp96_;
	gchar* _tmp153_;
	gchar* _tmp154_;
	gchar* _tmp155_;
	gchar* _tmp156_;
	gboolean result = FALSE;
#line 403 "../src/database.vala"
	g_return_val_if_fail (aBook != NULL, FALSE);
#line 404 "../src/database.vala"
	_tmp0_ = bookworm_app_book_to_string (aBook);
#line 404 "../src/database.vala"
	_tmp1_ = _tmp0_;
#line 404 "../src/database.vala"
	_tmp2_ = g_strconcat ("[START] [FUNCTION:updateBookToDataBase] Updating book to DB for the fo" \
"llowing details:", _tmp1_, NULL);
#line 404 "../src/database.vala"
	_tmp3_ = _tmp2_;
#line 404 "../src/database.vala"
	g_info ("database.vala:404: %s", _tmp3_);
#line 404 "../src/database.vala"
	_g_free0 (_tmp3_);
#line 404 "../src/database.vala"
	_g_free0 (_tmp1_);
#line 406 "../src/database.vala"
	_tmp4_ = g_strdup ("UPDATE " BOOKWORM_APP_DB_BOOKWORM_TABLE_NAME " SET BOOK_LAST_READ_PAGE_NUMBER = ?, " "BOOK_TITLE = ?, BOOK_AUTHOR = ?, BOOK_COVER_IMAGE_LOCATION = ?, " "IS_BOOK_COVER_IMAGE_PRESENT = ?, TAGS = ?, ANNOTATION_TAGS = ?, RATING" \
"S = ?, " "CONTENT_EXTRACTION_LOCATION = ?, BOOK_TOTAL_PAGES = ?, " "modification_date = CAST (? AS INT) WHERE ID = ? ");
#line 406 "../src/database.vala"
	_g_free0 (bookworm_app_db_queryString);
#line 406 "../src/database.vala"
	bookworm_app_db_queryString = _tmp4_;
#line 411 "../src/database.vala"
	_tmp5_ = bookworm_app_db_bookwormDB;
#line 411 "../src/database.vala"
	_tmp6_ = bookworm_app_db_queryString;
#line 411 "../src/database.vala"
	_tmp7_ = bookworm_app_db_queryString;
#line 411 "../src/database.vala"
	_tmp8_ = strlen (_tmp7_);
#line 411 "../src/database.vala"
	_tmp9_ = _tmp8_;
#line 411 "../src/database.vala"
	_tmp11_ = sqlite3_prepare_v2 (_tmp5_, _tmp6_, _tmp9_, &_tmp10_, NULL);
#line 411 "../src/database.vala"
	_sqlite3_finalize0 (stmt);
#line 411 "../src/database.vala"
	stmt = _tmp10_;
#line 411 "../src/database.vala"
	bookworm_app_db_executionStatus = _tmp11_;
#line 412 "../src/database.vala"
	if (bookworm_app_db_executionStatus != SQLITE_OK) {
#line 3738 "database.c"
		const gchar* _tmp12_;
		sqlite3* _tmp13_;
		sqlite3* _tmp14_;
		const gchar* _tmp15_;
#line 413 "../src/database.vala"
		_tmp12_ = bookworm_app_db_queryString;
#line 413 "../src/database.vala"
		_tmp13_ = bookworm_app_db_bookwormDB;
#line 413 "../src/database.vala"
		_tmp14_ = bookworm_app_db_bookwormDB;
#line 413 "../src/database.vala"
		_tmp15_ = sqlite3_errmsg (_tmp14_);
#line 413 "../src/database.vala"
		bookworm_app_db_report_query_execution_error (_tmp12_, sqlite3_errcode (_tmp13_), _tmp15_);
#line 414 "../src/database.vala"
		result = FALSE;
#line 414 "../src/database.vala"
		_sqlite3_finalize0 (stmt);
#line 414 "../src/database.vala"
		return result;
#line 3759 "database.c"
	}
#line 416 "../src/database.vala"
	_tmp16_ = stmt;
#line 416 "../src/database.vala"
	_tmp17_ = g_strdup_printf ("%i", bookworm_app_book_getBookPageNumber (aBook));
#line 416 "../src/database.vala"
	_tmp18_ = g_free;
#line 416 "../src/database.vala"
	sqlite3_bind_text (_tmp16_, 1, _tmp17_, -1, _tmp18_);
#line 417 "../src/database.vala"
	_tmp19_ = stmt;
#line 417 "../src/database.vala"
	_tmp20_ = bookworm_app_book_getBookTitle (aBook);
#line 417 "../src/database.vala"
	_tmp21_ = g_free;
#line 417 "../src/database.vala"
	sqlite3_bind_text (_tmp19_, 2, _tmp20_, -1, _tmp21_);
#line 418 "../src/database.vala"
	_tmp22_ = stmt;
#line 418 "../src/database.vala"
	_tmp23_ = bookworm_app_book_getBookAuthor (aBook);
#line 418 "../src/database.vala"
	_tmp24_ = g_free;
#line 418 "../src/database.vala"
	sqlite3_bind_text (_tmp22_, 3, _tmp23_, -1, _tmp24_);
#line 419 "../src/database.vala"
	_tmp25_ = stmt;
#line 419 "../src/database.vala"
	_tmp26_ = bookworm_app_book_getBookCoverLocation (aBook);
#line 419 "../src/database.vala"
	_tmp27_ = g_free;
#line 419 "../src/database.vala"
	sqlite3_bind_text (_tmp25_, 4, _tmp26_, -1, _tmp27_);
#line 420 "../src/database.vala"
	_tmp28_ = stmt;
#line 420 "../src/database.vala"
	_tmp29_ = bool_to_string (bookworm_app_book_getIsBookCoverImagePresent (aBook));
#line 420 "../src/database.vala"
	_tmp30_ = g_free;
#line 420 "../src/database.vala"
	sqlite3_bind_text (_tmp28_, 5, _tmp29_, -1, _tmp30_);
#line 421 "../src/database.vala"
	_tmp31_ = stmt;
#line 421 "../src/database.vala"
	_tmp32_ = bookworm_app_book_getBookTags (aBook);
#line 421 "../src/database.vala"
	_tmp33_ = g_free;
#line 421 "../src/database.vala"
	sqlite3_bind_text (_tmp31_, 6, _tmp32_, -1, _tmp33_);
#line 422 "../src/database.vala"
	_tmp34_ = stmt;
#line 422 "../src/database.vala"
	_tmp35_ = bookworm_app_book_getAnnotationTags (aBook);
#line 422 "../src/database.vala"
	_tmp36_ = g_free;
#line 422 "../src/database.vala"
	sqlite3_bind_text (_tmp34_, 7, _tmp35_, -1, _tmp36_);
#line 423 "../src/database.vala"
	_tmp37_ = stmt;
#line 423 "../src/database.vala"
	_tmp38_ = g_strdup_printf ("%i", bookworm_app_book_getBookRating (aBook));
#line 423 "../src/database.vala"
	_tmp39_ = g_free;
#line 423 "../src/database.vala"
	sqlite3_bind_text (_tmp37_, 8, _tmp38_, -1, _tmp39_);
#line 424 "../src/database.vala"
	_tmp40_ = stmt;
#line 424 "../src/database.vala"
	_tmp41_ = bookworm_app_book_getBookExtractionLocation (aBook);
#line 424 "../src/database.vala"
	_tmp42_ = g_free;
#line 424 "../src/database.vala"
	sqlite3_bind_text (_tmp40_, 9, _tmp41_, -1, _tmp42_);
#line 425 "../src/database.vala"
	_tmp43_ = stmt;
#line 425 "../src/database.vala"
	_tmp44_ = g_strdup_printf ("%i", bookworm_app_book_getBookTotalPages (aBook));
#line 425 "../src/database.vala"
	_tmp45_ = g_free;
#line 425 "../src/database.vala"
	sqlite3_bind_text (_tmp43_, 10, _tmp44_, -1, _tmp45_);
#line 426 "../src/database.vala"
	_tmp46_ = stmt;
#line 426 "../src/database.vala"
	_tmp47_ = bookworm_app_book_getBookLastModificationDate (aBook);
#line 426 "../src/database.vala"
	_tmp48_ = g_free;
#line 426 "../src/database.vala"
	sqlite3_bind_text (_tmp46_, 11, _tmp47_, -1, _tmp48_);
#line 427 "../src/database.vala"
	_tmp49_ = stmt;
#line 427 "../src/database.vala"
	sqlite3_bind_int (_tmp49_, 12, bookworm_app_book_getBookId (aBook));
#line 428 "../src/database.vala"
	_tmp50_ = stmt;
#line 428 "../src/database.vala"
	sqlite3_step (_tmp50_);
#line 429 "../src/database.vala"
	_tmp51_ = stmt;
#line 429 "../src/database.vala"
	sqlite3_reset (_tmp51_);
#line 430 "../src/database.vala"
	_tmp52_ = bookworm_app_book_getBookTitle (aBook);
#line 430 "../src/database.vala"
	_tmp53_ = _tmp52_;
#line 430 "../src/database.vala"
	_tmp54_ = g_strconcat ("Updated library details to " BOOKWORM_APP_DB_BOOKWORM_TABLE_NAME " for book:", _tmp53_, NULL);
#line 430 "../src/database.vala"
	_tmp55_ = _tmp54_;
#line 430 "../src/database.vala"
	_tmp56_ = g_strconcat (_tmp55_, "[", NULL);
#line 430 "../src/database.vala"
	_tmp57_ = _tmp56_;
#line 430 "../src/database.vala"
	_tmp58_ = g_strdup_printf ("%i", bookworm_app_book_getBookId (aBook));
#line 430 "../src/database.vala"
	_tmp59_ = _tmp58_;
#line 430 "../src/database.vala"
	_tmp60_ = g_strconcat (_tmp57_, _tmp59_, NULL);
#line 430 "../src/database.vala"
	_tmp61_ = _tmp60_;
#line 430 "../src/database.vala"
	_tmp62_ = g_strconcat (_tmp61_, "]", NULL);
#line 430 "../src/database.vala"
	_tmp63_ = _tmp62_;
#line 430 "../src/database.vala"
	g_debug ("database.vala:430: %s", _tmp63_);
#line 430 "../src/database.vala"
	_g_free0 (_tmp63_);
#line 430 "../src/database.vala"
	_g_free0 (_tmp61_);
#line 430 "../src/database.vala"
	_g_free0 (_tmp59_);
#line 430 "../src/database.vala"
	_g_free0 (_tmp57_);
#line 430 "../src/database.vala"
	_g_free0 (_tmp55_);
#line 430 "../src/database.vala"
	_g_free0 (_tmp53_);
#line 432 "../src/database.vala"
	_tmp64_ = g_strdup ("INSERT OR IGNORE INTO " BOOKWORM_APP_DB_BOOKMETADATA_TABLE_NAME " (BOOK_TOC_DATA, BOOKMARKS, " "CONTENT_DATA_LIST, BOOK_LAST_SCROLL_POSITION, BOOK_ANNOTATIONS, modifi" \
"cation_date, id) " "VALUES (?, ?, ?, ?, ?, CAST (strftime ('%s', 'now') AS INT), ?);");
#line 432 "../src/database.vala"
	_g_free0 (bookworm_app_db_queryString);
#line 432 "../src/database.vala"
	bookworm_app_db_queryString = _tmp64_;
#line 435 "../src/database.vala"
	_tmp65_ = bookworm_app_db_bookwormDB;
#line 435 "../src/database.vala"
	_tmp66_ = bookworm_app_db_queryString;
#line 435 "../src/database.vala"
	_tmp67_ = bookworm_app_db_queryString;
#line 435 "../src/database.vala"
	_tmp68_ = strlen (_tmp67_);
#line 435 "../src/database.vala"
	_tmp69_ = _tmp68_;
#line 435 "../src/database.vala"
	_tmp71_ = sqlite3_prepare_v2 (_tmp65_, _tmp66_, _tmp69_, &_tmp70_, NULL);
#line 435 "../src/database.vala"
	_sqlite3_finalize0 (stmt);
#line 435 "../src/database.vala"
	stmt = _tmp70_;
#line 435 "../src/database.vala"
	bookworm_app_db_executionStatus = _tmp71_;
#line 436 "../src/database.vala"
	if (bookworm_app_db_executionStatus != SQLITE_OK) {
#line 3925 "database.c"
		const gchar* _tmp72_;
		sqlite3* _tmp73_;
		sqlite3* _tmp74_;
		const gchar* _tmp75_;
#line 437 "../src/database.vala"
		_tmp72_ = bookworm_app_db_queryString;
#line 437 "../src/database.vala"
		_tmp73_ = bookworm_app_db_bookwormDB;
#line 437 "../src/database.vala"
		_tmp74_ = bookworm_app_db_bookwormDB;
#line 437 "../src/database.vala"
		_tmp75_ = sqlite3_errmsg (_tmp74_);
#line 437 "../src/database.vala"
		bookworm_app_db_report_query_execution_error (_tmp72_, sqlite3_errcode (_tmp73_), _tmp75_);
#line 438 "../src/database.vala"
		result = FALSE;
#line 438 "../src/database.vala"
		_sqlite3_finalize0 (stmt);
#line 438 "../src/database.vala"
		return result;
#line 3946 "database.c"
	}
#line 440 "../src/database.vala"
	_tmp76_ = stmt;
#line 440 "../src/database.vala"
	_tmp77_ = bookworm_app_utils_convertTOCToString (aBook);
#line 440 "../src/database.vala"
	_tmp78_ = g_free;
#line 440 "../src/database.vala"
	sqlite3_bind_text (_tmp76_, 1, _tmp77_, -1, _tmp78_);
#line 441 "../src/database.vala"
	_tmp79_ = stmt;
#line 441 "../src/database.vala"
	_tmp80_ = bookworm_app_book_getBookmark (aBook);
#line 441 "../src/database.vala"
	_tmp81_ = g_free;
#line 441 "../src/database.vala"
	sqlite3_bind_text (_tmp79_, 2, _tmp80_, -1, _tmp81_);
#line 442 "../src/database.vala"
	_tmp82_ = stmt;
#line 442 "../src/database.vala"
	_tmp83_ = bookworm_app_utils_convertContentListToString (aBook);
#line 442 "../src/database.vala"
	_tmp84_ = g_free;
#line 442 "../src/database.vala"
	sqlite3_bind_text (_tmp82_, 3, _tmp83_, -1, _tmp84_);
#line 443 "../src/database.vala"
	_tmp85_ = stmt;
#line 443 "../src/database.vala"
	_tmp86_ = g_strdup_printf ("%i", bookworm_app_book_getBookScrollPos (aBook));
#line 443 "../src/database.vala"
	_tmp87_ = g_free;
#line 443 "../src/database.vala"
	sqlite3_bind_text (_tmp85_, 4, _tmp86_, -1, _tmp87_);
#line 444 "../src/database.vala"
	_tmp88_ = stmt;
#line 444 "../src/database.vala"
	_tmp89_ = bookworm_app_book_getAnnotationList (aBook);
#line 444 "../src/database.vala"
	_tmp90_ = _tmp89_;
#line 444 "../src/database.vala"
	_tmp91_ = bookworm_app_utils_convertTreeMapToString (_tmp90_);
#line 444 "../src/database.vala"
	_tmp92_ = g_free;
#line 444 "../src/database.vala"
	sqlite3_bind_text (_tmp88_, 5, _tmp91_, -1, _tmp92_);
#line 444 "../src/database.vala"
	_g_object_unref0 (_tmp90_);
#line 445 "../src/database.vala"
	_tmp93_ = stmt;
#line 445 "../src/database.vala"
	sqlite3_bind_int (_tmp93_, 6, bookworm_app_book_getBookId (aBook));
#line 446 "../src/database.vala"
	_tmp94_ = stmt;
#line 446 "../src/database.vala"
	sqlite3_step (_tmp94_);
#line 447 "../src/database.vala"
	_tmp95_ = stmt;
#line 447 "../src/database.vala"
	sqlite3_reset (_tmp95_);
#line 448 "../src/database.vala"
	_tmp96_ = bookworm_app_db_bookwormDB;
#line 448 "../src/database.vala"
	if (sqlite3_changes (_tmp96_) == 0) {
#line 4010 "database.c"
		gchar* _tmp97_;
		sqlite3* _tmp98_;
		const gchar* _tmp99_;
		const gchar* _tmp100_;
		gint _tmp101_;
		gint _tmp102_;
		sqlite3_stmt* _tmp103_ = NULL;
		gint _tmp104_;
		sqlite3_stmt* _tmp109_;
		gchar* _tmp110_;
		GDestroyNotify _tmp111_;
		sqlite3_stmt* _tmp112_;
		gchar* _tmp113_;
		GDestroyNotify _tmp114_;
		sqlite3_stmt* _tmp115_;
		gchar* _tmp116_;
		GDestroyNotify _tmp117_;
		sqlite3_stmt* _tmp118_;
		gchar* _tmp119_;
		GDestroyNotify _tmp120_;
		sqlite3_stmt* _tmp121_;
		GeeTreeMap* _tmp122_;
		GeeTreeMap* _tmp123_;
		gchar* _tmp124_;
		GDestroyNotify _tmp125_;
		sqlite3_stmt* _tmp126_;
		sqlite3_stmt* _tmp127_;
		sqlite3_stmt* _tmp128_;
		gchar* _tmp129_;
		gchar* _tmp130_;
		gchar* _tmp131_;
		gchar* _tmp132_;
		gchar* _tmp133_;
		gchar* _tmp134_;
		gchar* _tmp135_;
		gchar* _tmp136_;
		gchar* _tmp137_;
		gchar* _tmp138_;
		gchar* _tmp139_;
		gchar* _tmp140_;
#line 450 "../src/database.vala"
		_tmp97_ = g_strdup ("UPDATE " BOOKWORM_APP_DB_BOOKMETADATA_TABLE_NAME " SET BOOK_TOC_DATA = ?, BOOKMARKS = ?, " "CONTENT_DATA_LIST = ?, BOOK_LAST_SCROLL_POSITION = ?, BOOK_ANNOTATIONS" \
" = ?, " "modification_date = CAST (strftime ('%s', 'now') AS INT) WHERE id = ? ");
#line 450 "../src/database.vala"
		_g_free0 (bookworm_app_db_queryString);
#line 450 "../src/database.vala"
		bookworm_app_db_queryString = _tmp97_;
#line 453 "../src/database.vala"
		_tmp98_ = bookworm_app_db_bookwormDB;
#line 453 "../src/database.vala"
		_tmp99_ = bookworm_app_db_queryString;
#line 453 "../src/database.vala"
		_tmp100_ = bookworm_app_db_queryString;
#line 453 "../src/database.vala"
		_tmp101_ = strlen (_tmp100_);
#line 453 "../src/database.vala"
		_tmp102_ = _tmp101_;
#line 453 "../src/database.vala"
		_tmp104_ = sqlite3_prepare_v2 (_tmp98_, _tmp99_, _tmp102_, &_tmp103_, NULL);
#line 453 "../src/database.vala"
		_sqlite3_finalize0 (stmt);
#line 453 "../src/database.vala"
		stmt = _tmp103_;
#line 453 "../src/database.vala"
		bookworm_app_db_executionStatus = _tmp104_;
#line 454 "../src/database.vala"
		if (bookworm_app_db_executionStatus != SQLITE_OK) {
#line 4077 "database.c"
			const gchar* _tmp105_;
			sqlite3* _tmp106_;
			sqlite3* _tmp107_;
			const gchar* _tmp108_;
#line 455 "../src/database.vala"
			_tmp105_ = bookworm_app_db_queryString;
#line 455 "../src/database.vala"
			_tmp106_ = bookworm_app_db_bookwormDB;
#line 455 "../src/database.vala"
			_tmp107_ = bookworm_app_db_bookwormDB;
#line 455 "../src/database.vala"
			_tmp108_ = sqlite3_errmsg (_tmp107_);
#line 455 "../src/database.vala"
			bookworm_app_db_report_query_execution_error (_tmp105_, sqlite3_errcode (_tmp106_), _tmp108_);
#line 456 "../src/database.vala"
			result = FALSE;
#line 456 "../src/database.vala"
			_sqlite3_finalize0 (stmt);
#line 456 "../src/database.vala"
			return result;
#line 4098 "database.c"
		}
#line 458 "../src/database.vala"
		_tmp109_ = stmt;
#line 458 "../src/database.vala"
		_tmp110_ = bookworm_app_utils_convertTOCToString (aBook);
#line 458 "../src/database.vala"
		_tmp111_ = g_free;
#line 458 "../src/database.vala"
		sqlite3_bind_text (_tmp109_, 1, _tmp110_, -1, _tmp111_);
#line 459 "../src/database.vala"
		_tmp112_ = stmt;
#line 459 "../src/database.vala"
		_tmp113_ = bookworm_app_book_getBookmark (aBook);
#line 459 "../src/database.vala"
		_tmp114_ = g_free;
#line 459 "../src/database.vala"
		sqlite3_bind_text (_tmp112_, 2, _tmp113_, -1, _tmp114_);
#line 460 "../src/database.vala"
		_tmp115_ = stmt;
#line 460 "../src/database.vala"
		_tmp116_ = bookworm_app_utils_convertContentListToString (aBook);
#line 460 "../src/database.vala"
		_tmp117_ = g_free;
#line 460 "../src/database.vala"
		sqlite3_bind_text (_tmp115_, 3, _tmp116_, -1, _tmp117_);
#line 461 "../src/database.vala"
		_tmp118_ = stmt;
#line 461 "../src/database.vala"
		_tmp119_ = g_strdup_printf ("%i", bookworm_app_book_getBookScrollPos (aBook));
#line 461 "../src/database.vala"
		_tmp120_ = g_free;
#line 461 "../src/database.vala"
		sqlite3_bind_text (_tmp118_, 4, _tmp119_, -1, _tmp120_);
#line 462 "../src/database.vala"
		_tmp121_ = stmt;
#line 462 "../src/database.vala"
		_tmp122_ = bookworm_app_book_getAnnotationList (aBook);
#line 462 "../src/database.vala"
		_tmp123_ = _tmp122_;
#line 462 "../src/database.vala"
		_tmp124_ = bookworm_app_utils_convertTreeMapToString (_tmp123_);
#line 462 "../src/database.vala"
		_tmp125_ = g_free;
#line 462 "../src/database.vala"
		sqlite3_bind_text (_tmp121_, 5, _tmp124_, -1, _tmp125_);
#line 462 "../src/database.vala"
		_g_object_unref0 (_tmp123_);
#line 463 "../src/database.vala"
		_tmp126_ = stmt;
#line 463 "../src/database.vala"
		sqlite3_bind_int (_tmp126_, 6, bookworm_app_book_getBookId (aBook));
#line 464 "../src/database.vala"
		_tmp127_ = stmt;
#line 464 "../src/database.vala"
		sqlite3_step (_tmp127_);
#line 465 "../src/database.vala"
		_tmp128_ = stmt;
#line 465 "../src/database.vala"
		sqlite3_reset (_tmp128_);
#line 466 "../src/database.vala"
		_tmp129_ = bookworm_app_book_getBookTitle (aBook);
#line 466 "../src/database.vala"
		_tmp130_ = _tmp129_;
#line 466 "../src/database.vala"
		_tmp131_ = g_strconcat ("Updated book meta data details to " BOOKWORM_APP_DB_BOOKMETADATA_TABLE_NAME " for book:", _tmp130_, NULL);
#line 466 "../src/database.vala"
		_tmp132_ = _tmp131_;
#line 466 "../src/database.vala"
		_tmp133_ = g_strconcat (_tmp132_, "[", NULL);
#line 466 "../src/database.vala"
		_tmp134_ = _tmp133_;
#line 466 "../src/database.vala"
		_tmp135_ = g_strdup_printf ("%i", bookworm_app_book_getBookId (aBook));
#line 466 "../src/database.vala"
		_tmp136_ = _tmp135_;
#line 466 "../src/database.vala"
		_tmp137_ = g_strconcat (_tmp134_, _tmp136_, NULL);
#line 466 "../src/database.vala"
		_tmp138_ = _tmp137_;
#line 466 "../src/database.vala"
		_tmp139_ = g_strconcat (_tmp138_, "]", NULL);
#line 466 "../src/database.vala"
		_tmp140_ = _tmp139_;
#line 466 "../src/database.vala"
		g_debug ("database.vala:466: %s", _tmp140_);
#line 466 "../src/database.vala"
		_g_free0 (_tmp140_);
#line 466 "../src/database.vala"
		_g_free0 (_tmp138_);
#line 466 "../src/database.vala"
		_g_free0 (_tmp136_);
#line 466 "../src/database.vala"
		_g_free0 (_tmp134_);
#line 466 "../src/database.vala"
		_g_free0 (_tmp132_);
#line 466 "../src/database.vala"
		_g_free0 (_tmp130_);
#line 4196 "database.c"
	} else {
		gchar* _tmp141_;
		gchar* _tmp142_;
		gchar* _tmp143_;
		gchar* _tmp144_;
		gchar* _tmp145_;
		gchar* _tmp146_;
		gchar* _tmp147_;
		gchar* _tmp148_;
		gchar* _tmp149_;
		gchar* _tmp150_;
		gchar* _tmp151_;
		gchar* _tmp152_;
#line 468 "../src/database.vala"
		_tmp141_ = bookworm_app_book_getBookTitle (aBook);
#line 468 "../src/database.vala"
		_tmp142_ = _tmp141_;
#line 468 "../src/database.vala"
		_tmp143_ = g_strconcat ("Inserted book meta data details to " BOOKWORM_APP_DB_BOOKMETADATA_TABLE_NAME " for book:", _tmp142_, NULL);
#line 468 "../src/database.vala"
		_tmp144_ = _tmp143_;
#line 468 "../src/database.vala"
		_tmp145_ = g_strconcat (_tmp144_, "[", NULL);
#line 468 "../src/database.vala"
		_tmp146_ = _tmp145_;
#line 468 "../src/database.vala"
		_tmp147_ = g_strdup_printf ("%i", bookworm_app_book_getBookId (aBook));
#line 468 "../src/database.vala"
		_tmp148_ = _tmp147_;
#line 468 "../src/database.vala"
		_tmp149_ = g_strconcat (_tmp146_, _tmp148_, NULL);
#line 468 "../src/database.vala"
		_tmp150_ = _tmp149_;
#line 468 "../src/database.vala"
		_tmp151_ = g_strconcat (_tmp150_, "]", NULL);
#line 468 "../src/database.vala"
		_tmp152_ = _tmp151_;
#line 468 "../src/database.vala"
		g_debug ("database.vala:468: %s", _tmp152_);
#line 468 "../src/database.vala"
		_g_free0 (_tmp152_);
#line 468 "../src/database.vala"
		_g_free0 (_tmp150_);
#line 468 "../src/database.vala"
		_g_free0 (_tmp148_);
#line 468 "../src/database.vala"
		_g_free0 (_tmp146_);
#line 468 "../src/database.vala"
		_g_free0 (_tmp144_);
#line 468 "../src/database.vala"
		_g_free0 (_tmp142_);
#line 4248 "database.c"
	}
#line 470 "../src/database.vala"
	_tmp153_ = bookworm_app_book_getBookLocation (aBook);
#line 470 "../src/database.vala"
	_tmp154_ = _tmp153_;
#line 470 "../src/database.vala"
	_tmp155_ = g_strconcat ("[END] [FUNCTION:updateBookToDataBase] book.location=", _tmp154_, NULL);
#line 470 "../src/database.vala"
	_tmp156_ = _tmp155_;
#line 470 "../src/database.vala"
	g_info ("database.vala:470: %s", _tmp156_);
#line 470 "../src/database.vala"
	_g_free0 (_tmp156_);
#line 470 "../src/database.vala"
	_g_free0 (_tmp154_);
#line 471 "../src/database.vala"
	result = TRUE;
#line 471 "../src/database.vala"
	_sqlite3_finalize0 (stmt);
#line 471 "../src/database.vala"
	return result;
#line 4270 "database.c"
}

GeeArrayList*
bookworm_app_db_getBookIDListFromDB (void)
{
	GeeArrayList* bookIDList = NULL;
	GeeArrayList* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	gint _tmp8_;
	sqlite3_stmt* _tmp24_;
	GeeArrayList* _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	GeeArrayList* result = NULL;
#line 475 "../src/database.vala"
	g_info ("database.vala:475: [START] [FUNCTION:getBookIDListFromDB]");
#line 476 "../src/database.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 476 "../src/database.vala"
	bookIDList = _tmp0_;
#line 478 "../src/database.vala"
	_tmp1_ = g_strdup ("SELECT id,BOOK_LOCATION FROM " BOOKWORM_APP_DB_BOOKWORM_TABLE_NAME " ORDER BY id DESC");
#line 478 "../src/database.vala"
	_g_free0 (bookworm_app_db_queryString);
#line 478 "../src/database.vala"
	bookworm_app_db_queryString = _tmp1_;
#line 479 "../src/database.vala"
	_tmp2_ = bookworm_app_db_bookwormDB;
#line 479 "../src/database.vala"
	_tmp3_ = bookworm_app_db_queryString;
#line 479 "../src/database.vala"
	_tmp4_ = bookworm_app_db_queryString;
#line 479 "../src/database.vala"
	_tmp5_ = strlen (_tmp4_);
#line 479 "../src/database.vala"
	_tmp6_ = _tmp5_;
#line 479 "../src/database.vala"
	_tmp8_ = sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 479 "../src/database.vala"
	_sqlite3_finalize0 (stmt);
#line 479 "../src/database.vala"
	stmt = _tmp7_;
#line 479 "../src/database.vala"
	bookworm_app_db_executionStatus = _tmp8_;
#line 480 "../src/database.vala"
	if (bookworm_app_db_executionStatus != SQLITE_OK) {
#line 4328 "database.c"
		const gchar* _tmp9_;
		sqlite3* _tmp10_;
		sqlite3* _tmp11_;
		const gchar* _tmp12_;
#line 481 "../src/database.vala"
		_tmp9_ = bookworm_app_db_queryString;
#line 481 "../src/database.vala"
		_tmp10_ = bookworm_app_db_bookwormDB;
#line 481 "../src/database.vala"
		_tmp11_ = bookworm_app_db_bookwormDB;
#line 481 "../src/database.vala"
		_tmp12_ = sqlite3_errmsg (_tmp11_);
#line 481 "../src/database.vala"
		bookworm_app_db_report_query_execution_error (_tmp9_, sqlite3_errcode (_tmp10_), _tmp12_);
#line 4343 "database.c"
	}
#line 483 "../src/database.vala"
	while (TRUE) {
#line 4347 "database.c"
		sqlite3_stmt* _tmp13_;
		GeeArrayList* _tmp14_;
		sqlite3_stmt* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		sqlite3_stmt* _tmp20_;
		const gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
#line 483 "../src/database.vala"
		_tmp13_ = stmt;
#line 483 "../src/database.vala"
		if (!(sqlite3_step (_tmp13_) == SQLITE_ROW)) {
#line 483 "../src/database.vala"
			break;
#line 4365 "database.c"
		}
#line 484 "../src/database.vala"
		_tmp14_ = bookIDList;
#line 484 "../src/database.vala"
		_tmp15_ = stmt;
#line 484 "../src/database.vala"
		_tmp16_ = g_strdup_printf ("%i", sqlite3_column_int (_tmp15_, 0));
#line 484 "../src/database.vala"
		_tmp17_ = _tmp16_;
#line 484 "../src/database.vala"
		_tmp18_ = g_strconcat (_tmp17_, "::", NULL);
#line 484 "../src/database.vala"
		_tmp19_ = _tmp18_;
#line 484 "../src/database.vala"
		_tmp20_ = stmt;
#line 484 "../src/database.vala"
		_tmp21_ = (const gchar*) sqlite3_column_text (_tmp20_, 1);
#line 484 "../src/database.vala"
		_tmp22_ = g_strconcat (_tmp19_, _tmp21_, NULL);
#line 484 "../src/database.vala"
		_tmp23_ = _tmp22_;
#line 484 "../src/database.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp23_);
#line 484 "../src/database.vala"
		_g_free0 (_tmp23_);
#line 484 "../src/database.vala"
		_g_free0 (_tmp19_);
#line 484 "../src/database.vala"
		_g_free0 (_tmp17_);
#line 4395 "database.c"
	}
#line 486 "../src/database.vala"
	_tmp24_ = stmt;
#line 486 "../src/database.vala"
	sqlite3_reset (_tmp24_);
#line 487 "../src/database.vala"
	_tmp25_ = bookIDList;
#line 487 "../src/database.vala"
	_tmp26_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp25_);
#line 487 "../src/database.vala"
	_tmp27_ = _tmp26_;
#line 487 "../src/database.vala"
	_tmp28_ = g_strdup_printf ("%i", _tmp27_);
#line 487 "../src/database.vala"
	_tmp29_ = _tmp28_;
#line 487 "../src/database.vala"
	_tmp30_ = g_strconcat ("[END] [FUNCTION:getBookIDListFromDB] bookIDList.size", _tmp29_, NULL);
#line 487 "../src/database.vala"
	_tmp31_ = _tmp30_;
#line 487 "../src/database.vala"
	g_info ("database.vala:487: %s", _tmp31_);
#line 487 "../src/database.vala"
	_g_free0 (_tmp31_);
#line 487 "../src/database.vala"
	_g_free0 (_tmp29_);
#line 488 "../src/database.vala"
	result = bookIDList;
#line 488 "../src/database.vala"
	_sqlite3_finalize0 (stmt);
#line 488 "../src/database.vala"
	return result;
#line 4427 "database.c"
}

static void
bookworm_app_db_report_query_execution_error (const gchar* query,
                                              gint errcode,
                                              const gchar* errmsg)
{
#line 491 "../src/database.vala"
	g_return_if_fail (query != NULL);
#line 491 "../src/database.vala"
	g_return_if_fail (errmsg != NULL);
#line 492 "../src/database.vala"
	g_debug ("database.vala:492: Error on executing Query: %s\n", query);
#line 493 "../src/database.vala"
	g_warning ("database.vala:493: Error (%d) details: %s\n", errcode, errmsg);
#line 4443 "database.c"
}

BookwormAppDB*
bookworm_app_db_construct (GType object_type)
{
	BookwormAppDB* self = NULL;
#line 22 "../src/database.vala"
	self = (BookwormAppDB*) g_type_create_instance (object_type);
#line 22 "../src/database.vala"
	return self;
#line 4454 "database.c"
}

BookwormAppDB*
bookworm_app_db_new (void)
{
#line 22 "../src/database.vala"
	return bookworm_app_db_construct (BOOKWORM_APP_TYPE_DB);
#line 4462 "database.c"
}

static void
bookworm_app_value_db_init (GValue* value)
{
#line 22 "../src/database.vala"
	value->data[0].v_pointer = NULL;
#line 4470 "database.c"
}

static void
bookworm_app_value_db_free_value (GValue* value)
{
#line 22 "../src/database.vala"
	if (value->data[0].v_pointer) {
#line 22 "../src/database.vala"
		bookworm_app_db_unref (value->data[0].v_pointer);
#line 4480 "database.c"
	}
}

static void
bookworm_app_value_db_copy_value (const GValue* src_value,
                                  GValue* dest_value)
{
#line 22 "../src/database.vala"
	if (src_value->data[0].v_pointer) {
#line 22 "../src/database.vala"
		dest_value->data[0].v_pointer = bookworm_app_db_ref (src_value->data[0].v_pointer);
#line 4492 "database.c"
	} else {
#line 22 "../src/database.vala"
		dest_value->data[0].v_pointer = NULL;
#line 4496 "database.c"
	}
}

static gpointer
bookworm_app_value_db_peek_pointer (const GValue* value)
{
#line 22 "../src/database.vala"
	return value->data[0].v_pointer;
#line 4505 "database.c"
}

static gchar*
bookworm_app_value_db_collect_value (GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
#line 22 "../src/database.vala"
	if (collect_values[0].v_pointer) {
#line 4516 "database.c"
		BookwormAppDB * object;
		object = collect_values[0].v_pointer;
#line 22 "../src/database.vala"
		if (object->parent_instance.g_class == NULL) {
#line 22 "../src/database.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4523 "database.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 22 "../src/database.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4527 "database.c"
		}
#line 22 "../src/database.vala"
		value->data[0].v_pointer = bookworm_app_db_ref (object);
#line 4531 "database.c"
	} else {
#line 22 "../src/database.vala"
		value->data[0].v_pointer = NULL;
#line 4535 "database.c"
	}
#line 22 "../src/database.vala"
	return NULL;
#line 4539 "database.c"
}

static gchar*
bookworm_app_value_db_lcopy_value (const GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
	BookwormAppDB ** object_p;
	object_p = collect_values[0].v_pointer;
#line 22 "../src/database.vala"
	if (!object_p) {
#line 22 "../src/database.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 4554 "database.c"
	}
#line 22 "../src/database.vala"
	if (!value->data[0].v_pointer) {
#line 22 "../src/database.vala"
		*object_p = NULL;
#line 4560 "database.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 22 "../src/database.vala"
		*object_p = value->data[0].v_pointer;
#line 4564 "database.c"
	} else {
#line 22 "../src/database.vala"
		*object_p = bookworm_app_db_ref (value->data[0].v_pointer);
#line 4568 "database.c"
	}
#line 22 "../src/database.vala"
	return NULL;
#line 4572 "database.c"
}

GParamSpec*
bookworm_app_param_spec_db (const gchar* name,
                            const gchar* nick,
                            const gchar* blurb,
                            GType object_type,
                            GParamFlags flags)
{
	BookwormAppParamSpecDB* spec;
#line 22 "../src/database.vala"
	g_return_val_if_fail (g_type_is_a (object_type, BOOKWORM_APP_TYPE_DB), NULL);
#line 22 "../src/database.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 22 "../src/database.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 22 "../src/database.vala"
	return G_PARAM_SPEC (spec);
#line 4591 "database.c"
}

gpointer
bookworm_app_value_get_db (const GValue* value)
{
#line 22 "../src/database.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BOOKWORM_APP_TYPE_DB), NULL);
#line 22 "../src/database.vala"
	return value->data[0].v_pointer;
#line 4601 "database.c"
}

void
bookworm_app_value_set_db (GValue* value,
                           gpointer v_object)
{
	BookwormAppDB * old;
#line 22 "../src/database.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BOOKWORM_APP_TYPE_DB));
#line 22 "../src/database.vala"
	old = value->data[0].v_pointer;
#line 22 "../src/database.vala"
	if (v_object) {
#line 22 "../src/database.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, BOOKWORM_APP_TYPE_DB));
#line 22 "../src/database.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 22 "../src/database.vala"
		value->data[0].v_pointer = v_object;
#line 22 "../src/database.vala"
		bookworm_app_db_ref (value->data[0].v_pointer);
#line 4623 "database.c"
	} else {
#line 22 "../src/database.vala"
		value->data[0].v_pointer = NULL;
#line 4627 "database.c"
	}
#line 22 "../src/database.vala"
	if (old) {
#line 22 "../src/database.vala"
		bookworm_app_db_unref (old);
#line 4633 "database.c"
	}
}

void
bookworm_app_value_take_db (GValue* value,
                            gpointer v_object)
{
	BookwormAppDB * old;
#line 22 "../src/database.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BOOKWORM_APP_TYPE_DB));
#line 22 "../src/database.vala"
	old = value->data[0].v_pointer;
#line 22 "../src/database.vala"
	if (v_object) {
#line 22 "../src/database.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, BOOKWORM_APP_TYPE_DB));
#line 22 "../src/database.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 22 "../src/database.vala"
		value->data[0].v_pointer = v_object;
#line 4654 "database.c"
	} else {
#line 22 "../src/database.vala"
		value->data[0].v_pointer = NULL;
#line 4658 "database.c"
	}
#line 22 "../src/database.vala"
	if (old) {
#line 22 "../src/database.vala"
		bookworm_app_db_unref (old);
#line 4664 "database.c"
	}
}

static void
bookworm_app_db_class_init (BookwormAppDBClass * klass,
                            gpointer klass_data)
{
#line 22 "../src/database.vala"
	bookworm_app_db_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/database.vala"
	((BookwormAppDBClass *) klass)->finalize = bookworm_app_db_finalize;
#line 4676 "database.c"
}

static void
bookworm_app_db_instance_init (BookwormAppDB * self,
                               gpointer klass)
{
#line 22 "../src/database.vala"
	self->ref_count = 1;
#line 4685 "database.c"
}

static void
bookworm_app_db_finalize (BookwormAppDB * obj)
{
	BookwormAppDB * self;
#line 22 "../src/database.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BOOKWORM_APP_TYPE_DB, BookwormAppDB);
#line 22 "../src/database.vala"
	g_signal_handlers_destroy (self);
#line 4696 "database.c"
}

static GType
bookworm_app_db_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { bookworm_app_value_db_init, bookworm_app_value_db_free_value, bookworm_app_value_db_copy_value, bookworm_app_value_db_peek_pointer, "p", bookworm_app_value_db_collect_value, "p", bookworm_app_value_db_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (BookwormAppDBClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bookworm_app_db_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BookwormAppDB), 0, (GInstanceInitFunc) bookworm_app_db_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType bookworm_app_db_type_id;
	bookworm_app_db_type_id = g_type_register_fundamental (g_type_fundamental_next (), "BookwormAppDB", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return bookworm_app_db_type_id;
}

GType
bookworm_app_db_get_type (void)
{
	static volatile gsize bookworm_app_db_type_id__volatile = 0;
	if (g_once_init_enter (&bookworm_app_db_type_id__volatile)) {
		GType bookworm_app_db_type_id;
		bookworm_app_db_type_id = bookworm_app_db_get_type_once ();
		g_once_init_leave (&bookworm_app_db_type_id__volatile, bookworm_app_db_type_id);
	}
	return bookworm_app_db_type_id__volatile;
}

gpointer
bookworm_app_db_ref (gpointer instance)
{
	BookwormAppDB * self;
	self = instance;
#line 22 "../src/database.vala"
	g_atomic_int_inc (&self->ref_count);
#line 22 "../src/database.vala"
	return instance;
#line 4731 "database.c"
}

void
bookworm_app_db_unref (gpointer instance)
{
	BookwormAppDB * self;
	self = instance;
#line 22 "../src/database.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 22 "../src/database.vala"
		BOOKWORM_APP_DB_GET_CLASS (self)->finalize (self);
#line 22 "../src/database.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 4745 "database.c"
	}
}

